VERSION 5.00
Begin VB.UserControl ICSA 
   ClientHeight    =   1095
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1725
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   1095
   ScaleWidth      =   1725
   ToolboxBitmap   =   "ICSA.ctx":0000
End
Attribute VB_Name = "ICSA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
''+-------------------------------------+
''| ICI style I/O ICSA interface module |
''+-------------------------------------+
''|     Made by Jure Sah of MesonAI     |
''|   TimeDateStamp:  17:33 30.6.2002   |
''+-------------------------------------+
''
''Type "ICSA." in the VB code editing screen to get
''a list of functions and subroutines this module
''provides. Each subroutine or function does what
''it 's name suggests and all parameters and their
''formats are just as obvious.
''
''This module provides your program with the
''abbility to use the ICSA program (Internet
''Communications and Security Agent) made by
''Neil Nelson, as if it were part of the program
''you are creating, with ease. Please consult the
''documentation of the ICSA program if you wish to
''know more of the ICSA's communications standard,
''altrough that knowledge is not required for using
''this module.
''
''This module requires all of the remaining modules,
''namely modules FILE, DATA, STATUS and IO that
''comply to the ICI standard, that are normaly
''included in this distribution.
''
''ICI ICSA interface (17:33 30.6.2002) License
''
''IMPORTANT:
''Please read the file license.txt carefully before
''using this software. By using, copying or
''redistributing the software, you accept and agree to
''become bound by the terms of the license. Please do
''not use this software, if you do not accept the terms
''of the license.
''
''ICI style I/O ICSA interface module (17:33 30.6.2002)
''(referred to in license.txt as "the software") has been
''developed by Jure Sah of MesonAI in Ljubljana, Slovenia.
''You can contact Jure Sah trough the following e-mail
''address:
''
''    jure.sah@guest.arnes.si
''
''or by any other means that you may find.
''

Public xICSAFile As String, iSource As String, icsaPleaseLogs As Boolean

Public icsaLogFile As String

Public Enum tProcessType
 Not_provided = 0
 FileLoc_link = 1
 ICSA_Process = 2
 MISC = 99
End Enum

Public Enum tPathType
 Plain = 1
 URL = 2
End Enum

Public Type tURL
 xProtocol As String
 xComputer As String
 xPath As String
End Type

Public icsaTmpRecieve As String
Private icsaTmpURLAnalize As tURL

Public Sub xFindInterfaceFile()
  If MasterDebugger Then On Error Resume Next
xICSAFile = Data.xQuery(Data.xFileLoc, "ICSA_COMM")
If icsaPleaseLogs Then
 File.xLog icsaLogFile, "Located ICSA interface directory at [" + xICSAFile + "]"
 File.xLog icsaLogFile, ""
End If
End Sub

Public Sub xSendText(xMyProcessName As String, xToProcess As String, xToProcessType As tProcessType, xTargetComputer As String, xText As String)
  If MasterDebugger Then On Error Resume Next
If xICSAFile = "" Then xFindInterfaceFile
''Use:
'' ICSA.xSendText "MyProcess", "ThatProcess", FileLoc_link Or ICSA_Process Or Not_provided, "Win_Somebody", "My message" + vbCrLf + "...may be multiline"

''Determine if message is single or multiline
'If InStr(xText, vbCrLf) = 0 Then
' ''No linebreaks found, one line
' tmp$ = "Message " + Chr$(34) + xText + Chr$(34)
'Else
 ''Linebreaks found, multiline
 tmp$ = Chr$(34) + Chr$(34) + xText
'End If
xSend xMyProcessName, xToProcess, xToProcessType, xTargetComputer, tmp$
If icsaPleaseLogs Then
 File.xLog icsaLogFile, "Sent text [" + tmp$ + "]"
 File.xLog icsaLogFile, " ProcessName = [" + xMyProcessName + "]"
 File.xLog icsaLogFile, " ToProcess = [" + xToProcess + "]"
 File.xLog icsaLogFile, " ToProcessType = [" + Trim$(Str$(xToProcessType)) + "]"
 File.xLog icsaLogFile, " TargetComputer = [" + xTargetComputer + "]"
End If
End Sub

Public Sub xSend(xMyProcessName As String, xToProcess As String, xToProcessType As tProcessType, xTargetComputer As String, xText As String)
  If MasterDebugger Then On Error Resume Next
If xICSAFile = "" Then xFindInterfaceFile
''Sends the command message to the ICSA.

If icsaPleaseLogs Then
 File.xLog icsaLogFile, "Supposed to send text [" + xText + "]"
 File.xLog icsaLogFile, " ProcessName = [" + xMyProcessName + "]"
 File.xLog icsaLogFile, " ToProcess = [" + xToProcess + "]"
 File.xLog icsaLogFile, " ToProcessType = [" + Trim$(Str$(xToProcessType)) + "]"
 File.xLog icsaLogFile, " TargetComputer = [" + xTargetComputer + "]"
End If

''If target not provided, use most recent message source (reply)
Select Case LCase$(xTargetComputer)
Case ""
 tmp3$ = "ToName " + iSource + vbCrLf
 If icsaPleaseLogs Then File.xLog icsaLogFile, " ToName set to source of last recieve!"
Case "[don't]", "[don't!]"
 tmp3$ = ""
 If icsaPleaseLogs Then File.xLog icsaLogFile, " ToName excluded!"
Case Else
 tmp3$ = "ToName " + xTargetComputer + vbCrLf
 If icsaPleaseLogs Then File.xLog icsaLogFile, " ToName set to [" + "ToName " + xTargetComputer + "]"
End Select
''Determine the appropriate ToProcess line (don't add if not provided)
Select Case xToProcessType
 Case Not_provided
  xToProcess = ""
  If icsaPleaseLogs Then File.xLog icsaLogFile, " ToProcess excluded!"
 Case FileLoc_link
  xToProcess = "ToFileLoc " + xToProcess + " interface" + vbCrLf
  If icsaPleaseLogs Then File.xLog icsaLogFile, " ToProcess set to standard FileLoc interface for [" + xToProcess + "]"
 Case ICSA_Process
  xToProcess = "ToProcess " + xToProcess + vbCrLf
 If icsaPleaseLogs Then File.xLog icsaLogFile, " ToProcess set to standard ICSA interface for [" + xToProcess + "]"
 Case Else
  xToProcess = xToProcess + vbCrLf
  If icsaPleaseLogs Then File.xLog icsaLogFile, " ToProcess left alone"
End Select
''Insert FromProcess line only if the SourceProcess is provided
If Not xMyProcessName = "" Then
 tmp1$ = "FromFileLoc " + Chr$(34) + xMyProcessName + " interface" + Chr$(34) + vbCrLf
 If icsaPleaseLogs Then File.xLog icsaLogFile, " SourceProcess set to [" + "FromFileLoc " + Chr$(34) + xMyProcessName + " interface" + Chr$(34) + "]"
Else
 tmp1$ = ""
 If icsaPleaseLogs Then File.xLog icsaLogFile, " SourceProcess excluded!"
End If

''Write it down
File.xWriteEntry Data.xNextSerialFile(xICSAFile), _
  tmp3$ _
+ tmp1$ _
+ xToProcess _
+ xText + vbCrLf
If icsaPleaseLogs Then File.xLog icsaLogFile, " Text sent"
End Sub

Public Function xRecieve(xMyProcessName As String) As String
  If MasterDebugger Then On Error Resume Next
'If xICSAFile = "" Then xFindInterfaceFile
''Use:
'' Recieved$ = ICSA.xRecieve("MyProcess")

'Dim xTheFile As String, tmp As String
'''Look for the FileLoc interface file
'xTheFile = Data.xQuery(data.xFileLoc , xMyProcessName + " interface")
'''If record missing, create it!
'If xTheFile = "" Then Data.xSet data.xFileLoc , xMyProcessName + " interface", App.Path + "\Input.POF"
'''Read the entry
'tmp = File.xReadEntry(xTheFile)
'''Extract the source
'iSource = File.xSplitSource(tmp).xSource
'''Extract the message
'xRecieve = File.xSplitSource(tmp).xMSG
'''Delete whatever recieved from POF
'If Not tmp = "" Then File.xDeleteEntry xTheFile

icsaTmpRecieve = IO.ioRecieve(xMyProcessName, Worker)
xRecieve = icsaTmpRecieve
iSource = IO.ioSource
End Function

Public Sub xDisplay(xTargetComputer As String, xText As String)
  If MasterDebugger Then On Error Resume Next
If xICSAFile = "" Then xFindInterfaceFile
''Use:
'' ICSA.xDisplay "Win_Somebody", "A message" + vbCrLf + "...may be multiline"
xSend "", "", Not_provided, xTargetComputer, xText
If icsaPleaseLogs Then File.xLog icsaLogFile, "Displaying [" + xText + "] on [" + xTargetComputer + "]"
End Sub

Public Sub xDirList(xMyProcessName As String, xTargetComputer As String, xPath As String, xPathType As tPathType)
  If MasterDebugger Then On Error Resume Next
If xICSAFile = "" Then xFindInterfaceFile
''Use:
'' ICSA.xDirList "MyProcess", "", "ici://ici_server/downloads/apps", URL

If icsaPleaseLogs Then File.xLog icsaLogFile, "Supposed to recieve directory list"

If xPathType = URL Then
 If icsaPleaseLogs Then File.xLog icsaLogFile, " Analizing provided URL"
 xTargetComputer = xURLAnalize(xPath).xComputer
 xPath = xURLAnalize(xPath).xPath
End If
If icsaPleaseLogs Then
 File.xLog icsaLogFile, " ProcessName = [" + xMyProcessName + "]"
 File.xLog icsaLogFile, " TargetComputer = [" + xTargetComputer + "]"
 File.xLog icsaLogFile, " Path = [" + xPath + "]"
End If

s$ = "fteAction Call_Directory" + vbCrLf + _
     "ToPath " + xPath + vbCrLf

xSend xMyProcessName, "", Not_provided, xTargetComputer, s$
End Sub

''S$ = "" + vbCrLf + _
''     "" + vbCrLf + _
''     "" + vbCrLf

Public Sub xUpload(xMyProcessName As String, xTargetComputer As String, xFromPath As String, xToPath As String, xToPathType As tPathType)
  If MasterDebugger Then On Error Resume Next
If xICSAFile = "" Then xFindInterfaceFile
''Use:
'' ICSA.xUpload "MyProcess", "", "C:\Autoexec.bat", "ici://ici_server/backups/Win_MyName", URL
''or
'' ICSA.xUpload "MyProcess", "ici_server", "C:\Autoexec.bat", "/backups/Win_MyName", Plain

If icsaPleaseLogs Then File.xLog icsaLogFile, "Supposed to upload"

If xToPathType = URL Then
 If icsaPleaseLogs Then File.xLog icsaLogFile, " Analizing provided URL"
 xTargetComputer = xURLAnalize(xToPath).xComputer
 xToPath = xURLAnalize(xToPath).xPath
End If

If icsaPleaseLogs Then
 File.xLog icsaLogFile, " ProcessName = [" + xMyProcessName + "]"
 File.xLog icsaLogFile, " TargetComputer = [" + xTargetComputer + "]"
 File.xLog icsaLogFile, " FromPath = [" + xFromPath + "]"
 File.xLog icsaLogFile, " ToPath = [" + xToPath + "]"
End If

If Trim$(xTargetComputer) = "0.0.0.0" Or UCase$(Trim$(xTargetComputer)) = UCase$(Trim$(STATUS.xGetLocalID)) Then
 FileSystem.FileCopy xFromPath, xToPath
 If icsaPleaseLogs Then File.xLog icsaLogFile, " File local, doing filecopy"
Else
 If icsaPleaseLogs Then File.xLog icsaLogFile, " Uploading"
 s$ = "fteAction Copy" + vbCrLf + _
      "FromPath " + xFromPath + vbCrLf + _
      "ToPath " + xToPath + vbCrLf

 xSend xMyProcessName, "", Not_provided, xTargetComputer, s$
End If
If icsaPleaseLogs Then File.xLog icsaLogFile, " Upload requesting complete"
End Sub

Public Sub xDownload(xMyProcessName As String, xTargetComputer As String, xFromPath As String, xFromPathType As tPathType, xToPath As String)
  If MasterDebugger Then On Error Resume Next
If xICSAFile = "" Then xFindInterfaceFile
''Use:
'' ICSA.xDownload "MyProcess", "", "ici://ici_server/downloads/ICSA1.exe", URL, "C:\ICI\ICSA"
''or
'' ICSA.xDownload "MyProcess", "ici_server", "/downloads/ICSA1.exe", Plain, "C:\ICI\ICSA"

If icsaPleaseLogs Then File.xLog icsaLogFile, "Supposed to download"

If xFromPathType = URL Then
 If icsaPleaseLogs Then File.xLog icsaLogFile, " Analizing provided URL"
 xTargetComputer = xURLAnalize(xFromPath).xComputer
 xFromPath = xURLAnalize(xFromPath).xPath
End If

If icsaPleaseLogs Then
 File.xLog icsaLogFile, " ProcessName = [" + xMyProcessName + "]"
 File.xLog icsaLogFile, " TargetComputer = [" + xTargetComputer + "]"
 File.xLog icsaLogFile, " FromPath = [" + xFromPath + "]"
 File.xLog icsaLogFile, " ToPath = [" + xToPath + "]"
End If

If Trim$(xTargetComputer) = "0.0.0.0" Or UCase$(Trim$(xTargetComputer)) = UCase$(Trim$(STATUS.xGetLocalID)) Then
 FileSystem.FileCopy xFromPath, xToPath
 If icsaPleaseLogs Then File.xLog icsaLogFile, " File local, doing filecopy"
Else
 If icsaPleaseLogs Then File.xLog icsaLogFile, " Downloading"
 s$ = "fteAction Copy" + vbCrLf + _
      "FromName " + xTargetComputer + vbCrLf + _
      "FromPath " + xFromPath + vbCrLf + _
      "ToPath " + xToPath + vbCrLf

 xSend xMyProcessName, "", Not_provided, "[don't]", s$
End If

If icsaPleaseLogs Then File.xLog icsaLogFile, " Download requesting complete"
End Sub

Public Sub xDelete(xMyProcessName As String, xTargetComputer As String, xPath As String, xPathType As tPathType)
  If MasterDebugger Then On Error Resume Next
If xICSAFile = "" Then xFindInterfaceFile
''Use:
'' ICSA.xDelete "MyProcess", "Win_Somebody", "C:\Temp\AFile.txt", Plain

If icsaPleaseLogs Then File.xLog icsaLogFile, "Supposed to delete"

If xPathType = URL Then
 If icsaPleaseLogs Then File.xLog icsaLogFile, " Analizing provided URL"
 xTargetComputer = xURLAnalize(xPath).xComputer
 xPath = xURLAnalize(xPath).xPath
End If

If icsaPleaseLogs Then
 File.xLog icsaLogFile, " ProcessName = [" + xMyProcessName + "]"
 File.xLog icsaLogFile, " TargetComputer = [" + xTargetComputer + "]"
 File.xLog icsaLogFile, " Path = [" + xPath + "]"
End If

s$ = "fteAction Delete" + vbCrLf + _
     "ToPath " + xPath + vbCrLf

xSend xMyProcessName, "", Not_provided, xTargetComputer, s$
If icsaPleaseLogs Then File.xLog icsaLogFile, " Delete requesting complete"
End Sub

'Private Sub xBroadcast(xMyProcessName As String, xToProcess As String, xToProcessType As tProcessType, xTargetGroup As String, xText As String)
'  if MasterDebugger then on error Resume Next
'If xICSAFile = "" Then xFindInterfaceFile
'''Sends the broadcast type command message to the ICSA.
'
'If icsaPleaseLogs Then
' File.xLog icsaLogFile, "Supposed to broadcast text [" + xText + "]"
' File.xLog icsaLogFile, " ProcessName = [" + xMyProcessName + "]"
' File.xLog icsaLogFile, " ToProcess = [" + xToProcess + "]"
' File.xLog icsaLogFile, " ToProcessType = [" + Trim$(Str$(xToProcessType)) + "]"
' File.xLog icsaLogFile, " TargetComputer = [" + xTargetComputer + "]"
'End If
'
'''Determine the appropriate ToProcess line (don't add if not provided)
'Select Case xToProcessType
' Case Not_provided
'  xToProcess = ""
'  If icsaPleaseLogs Then File.xLog icsaLogFile, " ToProcess excluded!"
' Case FileLoc_link
'  xToProcess = "ToFileLoc " + xToProcess + " interface" + vbCrLf
'  If icsaPleaseLogs Then File.xLog icsaLogFile, " ToProcess set to standard FileLoc interface for [" + xToProcess + "]"
' Case ICSA_Process
'  xToProcess = "ToProcess " + xToProcess + vbCrLf
' If icsaPleaseLogs Then File.xLog icsaLogFile, " ToProcess set to standard ICSA interface for [" + xToProcess + "]"
' Case Else
'  xToProcess = xToProcess + vbCrLf
'  If icsaPleaseLogs Then File.xLog icsaLogFile, " ToProcess left alone"
'End Select
'''Insert FromProcess line only if the SourceProcess is provided
'If Not xMyProcessName = "" Then tmp1$ = "FromProcess " + xMyProcessName + vbCrLf Else tmp1$ = ""
'
'''Write it down
'File.xWriteEntry Data.xNextSerialFile(xICSAFile), _
'  "ToGroup " + xTargetGroup + vbCrLf _
'+ tmp1$ _
'+ xToProcess _
'+ xText + vbCrLf
'End Sub
'
'Public Sub xBroadcastText(xMyProcessName As String, xToProcess As String, xToProcessType As tProcessType, xTargetGroup As String, xText As String)
'  if MasterDebugger then on error Resume Next
'If xICSAFile = "" Then xFindInterfaceFile
'''Use:
''' ICSA.xBroadcastText "MyProcess", "ThatProcess", FileLoc_link Or ICSA_Process Or Not_provided, "Win_Somebody", "My message" + vbCrLf + "...may be multiline"
'
'''Determine if message is single or multiline
''If InStr(xText, vbCrLf) = 0 Then
'' ''No linebreaks found, one line
'' tmp$ = "Message " + Chr$(34) + xText + Chr$(34)
''Else
' ''Linebreaks found, multiline
' tmp$ = Chr$(34) + Chr$(34) + xText
''End If
'xBroadcast xMyProcessName, xToProcess, xToProcessType, xTargetGroup, tmp$
'End Sub

Public Sub xDisconnect(xTargetComputer As String)
  If MasterDebugger Then On Error Resume Next
If xICSAFile = "" Then xFindInterfaceFile
''Use:
'' ICSA.xDisconnect "Win_Somebody"
File.xWriteEntry Data.xNextSerialFile(xICSAFile), "DisconnectName " + xTargetComputer
If icsaPleaseLogs Then File.xLog icsaLogFile, "Disconected [" + xTargetComputer + "]"
End Sub

Public Function xURLAnalize(xURL As String) As tURL
  If MasterDebugger Then On Error Resume Next
If xICSAFile = "" Then xFindInterfaceFile
xURLAnalize.xComputer = ""
xURLAnalize.xPath = ""
If InStr(xURL, ":") = 0 Then Exit Function
xURLAnalize.xProtocol = Mid$(xURL, 1, InStr(xURL, ":") - 1)
tmp1$ = Mid$(xURL, InStr(xURL, "//") + 2)
If InStr(tmp1$, "/") = 0 Then
 xURLAnalize.xComputer = STATUS.xGetLocalID
Else
 xURLAnalize.xComputer = Mid$(tmp1$, 1, InStr(tmp1$, "/") - 1)
End If
xURLAnalize.xPath = Mid$(tmp1$, InStr(tmp1$, "/") + 1)
icsaTmpURLAnalize = xURLAnalize
If icsaPleaseLogs Then
 File.xLog icsaLogFile, "Analized URL [" + xURL + "]"
 File.xLog icsaLogFile, " Protocol = [" + xURLAnalize.xProtocol + "]"
 File.xLog icsaLogFile, " Computer = [" + xURLAnalize.xComputer + "]"
 File.xLog icsaLogFile, " Path = [" + xURLAnalize.xPath + "]"
End If
End Function

Public Sub icsaEnableLogging(xBackups As Boolean)
If MasterDebugger Then On Error Resume Next
If xBackups Then
 If Dir$(App.Path + "\" + icsaLogFile + ".x") <> "" Then Kill App.Path + "\" + icsaLogFile + ".x"
 If Dir$(App.Path + "\" + icsaLogFile) <> "" Then Name App.Path + "\" + icsaLogFile As App.Path + "\" + icsaLogFile + ".x"
Else
 If Dir$(App.Path + "\" + icsaLogFile) <> "" Then Kill App.Path + "\" + icsaLogFile
End If
icsaPleaseLogs = True
End Sub

Private Sub UserControl_Initialize()
xFindInterfaceFile
End Sub
