VERSION 5.00
Begin VB.UserControl IO 
   ClientHeight    =   1095
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1620
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   1095
   ScaleWidth      =   1620
   ToolboxBitmap   =   "IO.ctx":0000
End
Attribute VB_Name = "IO"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
''+-------------------------------------+
''|    ICI Console interface module     |
''+-------------------------------------+
''|     Made by Jure Sah of MesonAI     |
''|    TimeDateStamp: 13:53 4.7.2003    |
''+-------------------------------------+
''
''Type "io." in the VB code editing screen to get
''a list of functions and subroutines this module
''provides. Each subroutine or function does what
''it 's name suggests and all parameters and their
''formats are just as obvious.
''
''This module provides your program with the abbility
''to communicate with the ICI Console program
''(responsible for managment of communications
''amongst multiple applications possibly over multiple
''computers) made by Jure Sah and in effect send and
''recieve commands accross the ICI network.
''
''There is an added capability in this module for use
''with commercial programs. Commercial programs, that
''have the string "[ICIProtected]" in their copyright
''message, and that were distributed via the
''copyprotection system by Neil Nelson, and used in
''conjuction with the complete ICI system, will
''recieve an automatic message from within the ICI
''system when we determine that your program has been
''illegaly duplicated somewhere, this will display a
''special message at the ICI Console and set the
''"ioCopyProtectionWarning" value to "True" within
''your program to let you make your program take
''whatever action when such a situation occurs.
''
''This modules requires modules DATA, FILE and STATUS
''that comply to the ICI standard and are normally
''included in this distribution.
''
''ICI Console interface (13:53 4.7.2003) License
''
''IMPORTANT:
''Please read the file license.txt carefully before
''using this software. By using, copying or
''redistributing the software, you accept and agree to
''become bound by the terms of the license. Please do
''not use this software, if you do not accept the terms
''of the license.
''
''ICI Console interface module (13:53 4.7.2003)
''(referred to in license.txt as "the software")
''has been developed by Jure Sah of MesonAI in
''Ljubljana, Slovenia. You can contact Jure Sah
''trough the following e-mail address:
''
''    jure.sah@guest.arnes.si
''
''or by any other means that you may find.
''

Public ioSource As String, ioPleaseLogs As Boolean, ioCopyProtectionWarning As Boolean
Public ioRecieveFor As String

Public ioLogFile As String

Enum tAppType
 Worker = 0
 Transmitter = 1
End Enum

Enum tCommand
 wpProvide_IP = 1
 xSynchronize = 2
 xSend_ID = 3
 xSend_ID_List = 4
 wpNew_ID = 5
 wpRemove_ID = 6
 wpStatus = 7
 wanEcho = 8
 wpPlug_Method = 9
End Enum

Public ioTmpRecieve As String

Public Function ioRecieve(xMyAppName As String, xMyAppType As tAppType) As String
    On Error Resume Next

Dim xTheFile As String, tmp As String
Select Case xMyAppType
Case Worker: g$ = "interface"
Case Transmitter: g$ = Trim$(ioRecieveFor + " outbox") ''Include ioRecieveFor if provided
End Select
''Look for the FileLoc interface file
xTheFile = Data.xQuery("C:\FileLoc", xMyAppName + " " + g$)
''If record missing, create it!
If xTheFile = "" Then Data.xSet "C:\FileLoc", xMyAppName + " " + g$, App.Path + "\" + Trim$(xMyAppName) + "." + g$ + ".POF"
''Read the entry
If FileLen(xTheFile) = 0 Then ioRecieve = "": Exit Function
tmp = File.xReadEntry(xTheFile)
''Delete whatever recieved from POF
If Not tmp = "" Then File.xDeleteEntry xTheFile
If InStr(1, tmp, "SET SOURCE", vbTextCompare) > 0 Then
 ''Extract the source
 ioSource = File.xSplitSource(tmp).xSource
 ''Extract the message
 ioRecieve = File.fTmpSplitSource.xMSG
Else
 ioSource = "0.0.0.0"
 ioRecieve = tmp
End If
If Trim$(ioRecieve) = "!" Then ioSend "", ioSource, "User:!!": ioRecieve = ""
If UCase$(Trim$(ioRecieve)) = "LOCK" And InStr(1, App.LegalCopyright, "ICIProtected", vbTextCompare) > 0 Then
 ioSend "", ioSource, "User: General copyprotection falioure in program " + MyApp + " (" + MyVersion + "; " + App.LegalCopyright + ")"
 ioCopyProtectionWarning = True
End If
ioTmpRecieve = ioRecieve
If ioPleaseLogs Then
 File.xLog ioLogFile, "Recieved [" + ioRecieve + "]"
 File.xLog ioLogFile, " Source = " + ioSource
 File.xLog ioLogFile, " AppName = " + xMyAppName
 File.xLog ioLogFile, " AppType = " + Trim$(Str$(xMyAppType))
End If
End Function

Public Sub ioSend(SourceComputer As String, ToComputer As String, Text As String)
 If MasterDebugger Then On Error Resume Next
Dim xTheFile As String, tmp As String
If SourceComputer = "" Then SourceComputer = "0.0.0.0"
xTheFile = Data.xQuery("C:\FileLoc", "ICIC PO Input")
If ToComputer = "" Or ToComputer = "0.0.0.0" Then
 tmp = "DO " + Text
Else
 tmp = "SENDTO [" + ToComputer + "] " + Text
End If
File.xWriteEntry xTheFile, File.xMergeSource(SourceComputer, tmp)
If ioPleaseLogs Then
 File.xLog ioLogFile, "Sent [" + File.xMergeSource(SourceComputer, tmp) + "] to [" + xTheFile + "]"
 File.xLog ioLogFile, " SourceComputer = " + SourceComputer
 File.xLog ioLogFile, " ToComputer = " + ToComputer
 File.xLog ioLogFile, " Text = " + Text
End If
End Sub

Public Sub ioControls(xMyAppName As String, SourceComputer As String, xCommand As tCommand, Parameter As String)
 If MasterDebugger Then On Error Resume Next
Select Case xCommand
 Case wpProvide_IP: s$ = "Shell: IP," + Parameter
 Case xSynchronize: s$ = "Shell: Please synchronize"
 Case xSend_ID: s$ = "Shell: Send ID"
 Case xSend_ID_List: s$ = "Shell: Send ID List"
 Case wpNew_ID: s$ = "Shell: ID," + Parameter
 Case wpRemove_ID: s$ = "Shell: Remove," + Parameter
 Case wpStatus: s$ = "Shell: Status," + Parameter
 Case wanEcho: s$ = "Shell: Return, " + xMyAppName + ": Echo reply"
 Case wpPlug_Method: s$ = "Shell: ICI Plug," + Parameter
End Select
ioSend SourceComputer, "0.0.0.0", s$
If ioPleaseLogs Then
 File.xLog ioLogFile, "Converted control command; output = [" + s$ + "]"
 File.xLog ioLogFile, "AppName = " + xMyAppName
 File.xLog ioLogFile, "SourceComputer = " + SourceComputer
 File.xLog ioLogFile, "Command = " + Trim$(Str$(xCommand))
 File.xLog ioLogFile, "Parameter = " + Parameter
End If
End Sub

Public Sub ioRespond(Text As String)
 If MasterDebugger Then On Error Resume Next
ioSend STATUS.xGetLocalID, ioSource, Text
End Sub

Public Sub ioEnableLogging(xBackups As Boolean)
 On Error Resume Next
If Backups Then
 Kill App.Path + "\" + ioLogFile + ".x"
 Name App.Path + "\" + ioLogFile As App.Path + "\" + ioLogFile + ".x"
Else
 Kill App.Path + "\" + ioLogFile
End If
ioPleaseLogs = True
End Sub


