VERSION 5.00
Begin VB.UserControl STATUS 
   ClientHeight    =   1035
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1290
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   1035
   ScaleWidth      =   1290
   ToolboxBitmap   =   "STATUS.ctx":0000
End
Attribute VB_Name = "STATUS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
''+-------------------------------------+
''| ICI STATUS databank registry module |
''+-------------------------------------+
''|     Made by Jure Sah of MesonAI     |
''|   TimeDateStamp:  18:38 30.6.2002   |
''+-------------------------------------+
''
''Type "me." in the VB code editing screen to
''get a list of functions and subroutines this
''module provides. Each subroutine or function
''does what it's name suggests and all parameters
''and their formats are just as obvious.
''
''This module provides your program with the
''abbility to register, unregister and record or
''retrieve other kinds of information and run other
''STATUS registered applications based on the ICI
''standard STATUS databank.
''
''This module requires modules DATA and FILE that
''comply to the ICI standard and are normaly
''included in this distribution. All
''characteristics that apply to other ICI
''standard databanks also apply to the ICI
''standard STATUS databank.
''
''ICI STATUS (18:38 30.6.2002) License
''
''IMPORTANT:
''Please read the file license.txt carefully before
''using this software. By using, copying or
''redistributing the software, you accept and agree to
''become bound by the terms of the license. Please do
''not use this software, if you do not accept the terms
''of the license.
''
''ICI STATUS databank registry module (18:38 30.6.2002)
''(referred to in license.txt as "the software") has
''been developed by Jure Sah of MesonAI in Ljubljana,
''Slovenia. You can contact Jure Sah trough the
''following e-mail address:
''
''    jure.sah@guest.arnes.si
''
''or by any other means that you may find.
''

Public xdSTATUS As String, xdPleaseLogs As Boolean, xdNoDebug As Boolean

Public xdLoadOnce As Boolean

Public xdLogFile As String

Public xdTmpQueryExtraRegister As String
Public xdTmpGetLocalID As String
Public xdTmpGetICIPulse As Long
Public xdTmpIsAppRunning As Boolean
Public xdTmpGetAppRunTime As String
Public xdTmpGetAppRunDate As String
Public xdTmpGetAppRunPath As String
Public xdTmpIsAppInstalled As Boolean

Public Sub xLocateSTATUSDataBank()
If MasterDebugger Then On Error Resume Next
Dim xyzStart As Long
xdSTATUS = Data.xQuery(Data.xFileLoc, "STATUS")
If xdSTATUS = "" Then xdSTATUS = Data.xTemporaryPath + "\STATUS": Data.xSet Data.xFileLoc, "STATUS", xdSTATUS
If xdPleaseLogs Then File.xLog xdLogFile, "Located STATUS databank in [" + xdSTATUS + "]"
If Me.xIsAppInstalled("Upkeep") And Not xdNoDebug Then
 ''If file bigger than 30k, automaticaly run Upkeep
 If xdPleaseLogs Then File.xLog xdLogFile, "Databank size [" + CStr(FileSystem.FileLen(xdSTATUS)) + "]"
 If FileSystem.FileLen(xdSTATUS) > 30720 Then
  MsgBox "The STATUS databank size has been determined to be too big (over 30k), which would otherwise cause this application to stop responding. " + vbCrLf + vbCrLf + "This application will now wait until the error is repaired and then resume loading." + vbCrLf + vbCrLf + "Press OK to begin.", vbExclamation, "ICI STATUS subsystem"
  If xdPleaseLogs Then File.xLog xdLogFile, "Problem. Starting Upkeep program."
  Me.xMakeAppRunning "Upkeep", vbMinimizedNoFocus
  ''Wait until it finnishes
  Do
   If Abs(DateTime.Timer - xyzStart) >= 1 Then
    xyzStart = DateTime.Timer
    If xdPleaseLogs Then File.xLog xdLogFile, "Waiting..."
    If FileSystem.FileLen(xdSTATUS) < 51200 Then
     If Not Me.xIsAppRunning("Upkeep") Then Exit Do
    End If
   End If
  Loop
  If xdPleaseLogs Then File.xLog xdLogFile, "Upkeep program finnished."
 End If
End If
If xdPleaseLogs Then File.xLog xdLogFile, ""
End Sub

Public Sub xRegister(xMyAppName As String)
If MasterDebugger Then On Error Resume Next
1 If xdSTATUS = "" Then xLocateSTATUSDataBank
Data.xSet xdSTATUS, xMyAppName + " running", "Yes"
Data.xSet xdSTATUS, xMyAppName + " last login date", Date$
Data.xSet xdSTATUS, xMyAppName + " last login time", Time$
Data.xSet xdSTATUS, xMyAppName + " path", App.Path + "\" + App.EXEName + ".EXE"
If xdPleaseLogs Then File.xLog xdLogFile, "Registered application [" + xMyAppName + "] at [" + App.Path + "\" + App.EXEName + ".EXE]"
was$ = Data.xQuery(xdSTATUS, xMyAppName + " running")
If UCase$(Trim$(was$)) <> "YES" Then
 If xdPleaseLogs Then File.xLog xdLogFile, "Registration was unsuccesfull [" + was$ + "]. Retrying..."
 GoTo 1
End If
End Sub

Public Sub xRegisterExtra(xMyAppName As String, Register As String, Value As String)
If MasterDebugger Then On Error Resume Next
If xdSTATUS = "" Then xLocateSTATUSDataBank
Data.xSet xdSTATUS, xMyAppName + " " + Register, Value
If xdPleaseLogs Then File.xLog xdLogFile, "Registered additional information (" + Register + ") for [" + xMyAppName + "]: [" + Value + "]"
End Sub

Public Sub xUnRegister(xMyAppName As String)
If MasterDebugger Then On Error Resume Next
If xdSTATUS = "" Then xLocateSTATUSDataBank
Data.xSet xdSTATUS, xMyAppName + " running", "No"
If xdPleaseLogs Then File.xLog xdLogFile, "Unregistered application [" + xMyAppName + "]"
End Sub

Public Function xQueryExtraRegister(xMyAppName As String, Register As String) As String
If MasterDebugger Then On Error Resume Next
If xdSTATUS = "" Then xLocateSTATUSDataBank
xdTmpQueryExtraRegister = Data.xQuery(xdSTATUS, xMyAppName + " " + Register)
xQueryExtraRegister = xdTmpQueryExtraRegister
If xdPleaseLogs Then File.xLog xdLogFile, "Retrieved additional information (" + Register + ") for [" + xMyAppName + "]: [" + xQueryExtraRegister + "]"
End Function

Public Function xGetLocalID() As String
If MasterDebugger Then On Error Resume Next
''AutoDeCache?
If xdLoadOnce And xdTmpGetLocalID <> "" Then xGetLocalID = xdTmpGetLocalID: Exit Function
If xdSTATUS = "" Then xLocateSTATUSDataBank
xdTmpGetLocalID = Data.xQuery(xdSTATUS, "Local ID")
xGetLocalID = xdTmpGetLocalID
If xdPleaseLogs Then File.xLog xdLogFile, "Retrieved local ID as [" + xGetLocalID + "]"
End Function

Public Function xGetICIPulse() As Long
If MasterDebugger Then On Error Resume Next
If xdSTATUS = "" Then xLocateSTATUSDataBank
xPulse = Val(Data.xQuery(xdSTATUS, "Pulse"))
If xPulse = 0 Then Data.xSet xdSTATUS, "Pulse", "1000": xPulse = 1000
If xdPleaseLogs Then File.xLog xdLogFile, "Retrieved ICI Pulse as [" + Str$(xPulse) + "]"
xdTmpGetICIPulse = xPulse
xGetICIPulse = xPulse
End Function

Public Function xIsAppRunning(xAppName As String) As Boolean
If MasterDebugger Then On Error Resume Next
If xdSTATUS = "" Then xLocateSTATUSDataBank
xdTmpIsAppRunning = (UCase$(Trim$(Data.xQuery(xdSTATUS, xAppName + " running"))) = "YES")
xIsAppRunning = xdTmpIsAppRunning
If xdPleaseLogs Then File.xLog xdLogFile, "Determined if [" + xAppName + "] is running as [" + Trim$(Str$(xIsAppRunning)) + "]"
End Function

Public Sub xRunApp(xAppName As String, WindowStyle As VBA.VbAppWinStyle)
If MasterDebugger Then On Error Resume Next
If xdSTATUS = "" Then xLocateSTATUSDataBank
xdPath$ = Data.xQuery(xdSTATUS, xAppName + " path")
Shell xdPath$, WindowStyle
If xdPleaseLogs Then File.xLog xdLogFile, "Running application [" + xAppName + "] (path is [" + xdPath$ + "]) in state [" + Trim$(Str$(WindowStyle)) + "]"
End Sub

Public Sub xMakeAppRunning(xAppName As String, WindowStyle As VBA.VbAppWinStyle)
If MasterDebugger Then On Error Resume Next
Dim xdStart As Long
If xdSTATUS = "" Then xLocateSTATUSDataBank
If xdPleaseLogs Then File.xLog xdLogFile, "Supposed to make sure [" + xAppName + "] is running..."
If xIsAppInstalled(xAppName) Then
 If Not xIsAppRunning(xAppName) Then
  If xdPleaseLogs Then File.xLog xdLogFile, " App found not to be running"
  xRunApp xAppName, WindowStyle
  If Not xIsAppRunning(xAppName) Then
   If xdPleaseLogs Then File.xLog xdLogFile, " App not yet running, waiting..."
   Do: xdStart = DateTime.Timer
    Data.xModerateDataCache xAppName + " running"
    Do: DoEvents
    Loop Until Abs(DateTime.Timer - xdStart) >= 1
   Loop Until xIsAppRunning(xAppName)
  End If
 End If
 If xdPleaseLogs Then File.xLog xdLogFile, " App now running!"
Else
 If xdPleaseLogs Then File.xLog xdLogFile, " App not installed"
End If
End Sub

Public Function xGetAppRunTime(xAppName As String) As String
If MasterDebugger Then On Error Resume Next
If xdSTATUS = "" Then xLocateSTATUSDataBank
xdTmpGetAppRunTime = Data.xQuery(xdSTATUS, xAppName + " last login time")
xGetAppRunTime = xdTmpGetAppRunTime
If xdPleaseLogs Then File.xLog xdLogFile, "Application [" + xAppName + "]'s run time determined to be [" + xGetAppRunTime + "]"
End Function

Public Function xGetAppRunDate(xAppName As String) As String
If MasterDebugger Then On Error Resume Next
If xdSTATUS = "" Then xLocateSTATUSDataBank
xdTmpGetAppRunDate = Data.xQuery(xdSTATUS, xAppName + " last login date")
xGetAppRunDate = xdTmpGetAppRunDate
If xdPleaseLogs Then File.xLog xdLogFile, "Application [" + xAppName + "]'s run date determined to be [" + xGetAppRunDate + "]"
End Function

Public Function xGetAppRunPath(xAppName As String) As String
If MasterDebugger Then On Error Resume Next
If xdSTATUS = "" Then xLocateSTATUSDataBank
xdTmpGetAppRunPath = Data.xQuery(xdSTATUS, xAppName + " path")
xGetAppRunPath = xdTmpGetAppRunPath
If xdPleaseLogs Then File.xLog xdLogFile, "Application [" + xAppName + "]'s run path determined to be [" + xGetAppRunPath + "]"
End Function

Public Sub xdEnableLogging(xBackups As Boolean)
If MasterDebugger Then On Error Resume Next
If Backups Then
 If Dir$(App.Path + "\" + xdLogFile + ".x") <> "" Then Kill App.Path + "\" + xdLogFile + ".x"
 If Dir$(App.Path + "\" + xdLogFile) <> "" Then Name App.Path + "\" + xdLogFile As App.Path + "\" + xdLogFile + ".x"
Else
 If Dir$(App.Path + "\" + xdLogFile) <> "" Then Kill App.Path + "\" + xdLogFile
End If
xdPleaseLogs = True
End Sub

Public Function xIsAppInstalled(xAppName As String) As Boolean
If MasterDebugger Then On Error Resume Next
If xdSTATUS = "" Then xLocateSTATUSDataBank
xdTmpIsAppInstalled = Not (Trim$(Data.xQuery(xdSTATUS, xAppName + " path")) = "")
xIsAppInstalled = xdTmpIsAppInstalled
If xdPleaseLogs Then File.xLog xdLogFile, "Determined if [" + xAppName + "] is installed as [" + Trim$(Str$(xIsAppInstalled)) + "]"
End Function

Private Sub UserControl_Initialize()
xLocateSTATUSDataBank
End Sub
