VERSION 5.00
Begin VB.UserControl Data 
   ClientHeight    =   720
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   720
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   720
   ScaleWidth      =   720
   ToolboxBitmap   =   "Data.ctx":0000
End
Attribute VB_Name = "Data"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
''+-------------------------------------------+
''| ICI style I/O database file access module |
''+-------------------------------------------+
''|       Made by Jure Sah of MesonAI         |
''|      TimeDateStamp: 17:07 6.7.2003        |
''+-------------------------------------------+
''
''Type "me." in the VB code editing screen to get
''a list of functions and subroutines this module
''provides. Each subroutine or function does what
''it's name suggests and all parameters and their
''formats are just as obvious.
''
''This module provides your program with the abbility
''to store and retrieve data from ICI databanks with
''ease and efficiency. ICI databanks are
''easily-accessable text files that contain
''information in the following format:
''
'' Property1 = ValueA
'' Property2 = ValueB
'' Property3 = ValueC
''
''ICI databanks are interconnectable, by providing the
'' filename of another databank as the value of a
''specific property of the first databank. The root
''databank in the ICI standard is called C:\FileLoc.
''
''ICI DATA (17:07 6.7.2003) License
''
''IMPORTANT:
''Please read the file license.txt carefully before
''using this software. By using, copying or
''redistributing the software, you accept and agree to
''become bound by the terms of the license. Please do
''not use this software, if you do not accept the terms
''of the license.
''
''ICI style I/O database file access module (17:07
''6.7.2003) (referred to in license.txt as "the
''software") has been developed by Jure Sah of MesonAI
''in Ljubljana, Slovenia. You can contact Jure Sah
''trough the following e-mail address:
''
''    jure.sah@guest.arnes.si
''
''or by any other means that you may find.
''

Type xPropertyAndValue
 xProperty As String
 xValue As String
End Type

Public xFileLoc As String

''These can be changed from your program to control how data is accessed
Public xTemporaryPath As String
Public DataFilesPath As String
Public xPleaseLogs As Boolean
Public xWaitFile As Boolean
Public xNoOutputCaching As Boolean
Public xNoCaching As Boolean
Public xInnitializing As Boolean
Public xProcFinnished As Boolean

Private xQueryCachedName(3) As String, xQueryCachedSysTDS(3) As String, xQueryCachedProperty(3) As String, xQueryCachedValue(3) As String, xQueryCachedPos As Byte
Private xQueryBLNCachedName(3) As String, xQueryBLNCachedSysTDS(3) As String, xQueryBLNCachedLN(3) As Long, xQueryBLNCachedValue(3) As xPropertyAndValue, xQueryBLNCachePos As Byte
Private xSetCachedName(3) As String, xSetCachedSysTDS(3) As String, xSetCachedProperty(3) As String, xSetCachedValue(3) As String, xSetCachedPos As Byte
Private xNextSerialCachedName(3) As String, xNextSerialCachedSysTDS(3) As String, xNextSerialCachedProperty(3) As String, xNextSerialCachedSerial(3) As Long, xNextSerialCachedPos As Byte
Private xByLineCachedName(3) As String, xByLineCachedSysTDS(3) As String, xByLineCachedNumberOfLines(3) As Long, xByLineCachedPos As Byte

Private xProblematicSwapFN As String, xProblematicSwapTimer As Long
Public xTmpFixName As String, xOrigFixName As String

Public Sub xFindTemporaryPath()
xProcFinnished = False
 
 On Error Resume Next
xInnitializing = True
xFileLoc = "C:\FileLoc"
Dim Msng As Boolean: Msng = False
xTemporaryPath = xQuery(Me.xFileLoc, "Temporary path")
If xTemporaryPath = "" Then xTemporaryPath = Environ$("ICI"): Msng = True
If xTemporaryPath = "" Then xTemporaryPath = Environ$("TEMP")
If xTemporaryPath = "" Then xTemporaryPath = Environ$("TMP")
If xTemporaryPath = "" Then xTemporaryPath = App.Path
If Msng Then xSet xFileLoc, "Temporary path", xTemporaryPath
DataFilesPath = App.Path
If xPleaseLogs Then
 dLog "Innitialized databank access with tempdir [" + xTemporaryPath + "], runpath [" + DataFilesPath + "]"
 dLog "   "
End If
xInnitializing = False
xProcFinnished = True
End Sub

Public Function xFixName(xName As String) As String
xProcFinnished = False
''Filename problem handler
    On Error Resume Next
If Not xNoCaching Then
 If xOrigFixName = xName Then xFixName = xTmpFixName: Exit Function
 xOrigFixName = xName
End If
If xTemporaryPath = "" And Not xInnitializing Then xFindTemporaryPath
xFile$ = ""
If Not DataFilesPath = "" And Not InStr(xName, ":") > 0 Then xDefPath$ = DataFilesPath + "\"
xFile$ = xDefPath$ + xName
If Left$(xFile$, 1) = "\" Then xFile$ = xTemporaryPath + xFile$
xTmpFixName = xFile$
xFixName = xTmpFixName
xProcFinnished = True
End Function

Public Sub xCreate(xName As String)
xProcFinnished = False

''Create a new database or insure it exists
    On Error Resume Next
xFile$ = xFixName(xName)

''Does it already exist?
If xFile$ = "" Or Right$(xFile$, 1) = "\" Then Exit Sub
If Dir(xFile$) = "" Then
 ''Place emptyness in new file
 OutputFN = FreeFile
 Open xFile$ For Output As #OutputFN
  Print #OutputFN, "INTERNAL FLAG = EXISTS!"
  Print #OutputFN, "TDS = " + Time$ + " " + Date$
 Close #OutputFN
Else
 ''Reconstruct basic databank information
 If xQuery(xName, "TDS") = "" Then xSet xName, "TDS", FileSystem.FileDateTime(xFile$)
 If xQuery(xName, "INTERNAL FLAG") <> "EXISTS!" Then xSet xName, "INTERNAL FLAG", "EXISTS!"
End If
Close #OutputFN

xProcFinnished = True
End Sub

Public Sub xRemove(xName As String)
xProcFinnished = False

''Delete a database
    On Error Resume Next
xFile$ = xFixName(xName)

''Does it really exist?
If Dir(xFile$) <> "" Then
 If UCase$(Trim$(xQuery(xName, "Unreal delete"))) = "YES" Then
  xSet xName, "INTERNAL FLAG", "DELETED!"
 Else
  Kill xFile$
 End If
End If
xProcFinnished = True
End Sub

Public Sub xSet(xName As String, xProperty As String, xValue As String)
xProcFinnished = False
    ''--------------------------------------
    ''New ASCII/ByteSeek hybrid method below
    ''--------------------------------------

''Set a value to a property
    On Error Resume Next

If Trim$(xName) = "" Or Trim$(xProperty) = "" Then Exit Sub

methd$ = ""

''Set filenames
xFile$ = xFixName(xName)
If xFile$ = "" Then Exit Sub
If Right$(xFile$, 1) = "\" Then Exit Sub

If Trim$(xValue) = "" Then methd$ = methd$ + "Removing. ": GoTo 3

If Not xNoOutputCaching And Not xNoCaching Then
 ''DeCache from Set cache
 For c = 0 To 3
  If Trim$(xSetCachedName(c)) = Trim$(xFile$) And Trim$(CStr(FileDateTime(xFile$)) + " " + CStr(FileSystem.FileLen(xFile$))) = Trim$(xSetCachedSysTDS(c)) And Trim$(xSetCachedProperty(c)) = Trim$(xProperty) And Trim$(xSetCachedValue(c)) = Trim$(xValue) Then
   If xPleaseLogs Then dLog "Database " + Trim$(xFile$) + " Set [" + Trim$(xProperty) + "] ==>> DeCached from write cache [" + Trim$(xSetCachedValue(c)) + "] value already recorded"
   Exit Sub
  End If
 Next c
End If

Dim e As String * 1, f As String * 1
If Dir$(xFile) <> "" Then
 FA = FreeFile
 Open xFile$ For Input As #FA
 n = 0: m1 = 0: m2 = 0: m3 = 0
 Do Until EOF(FA)
  Line Input #FA, x$
  n = n + 1 ''+ LF; position
  m2 = Len(x$) ''Line lenght
  m3 = InStr(Trim$(x$), "=") ''Position of "=" sign
  If UCase$(Trim$(Mid$(Trim$(x$), 1, m3 - 1))) = UCase$(Trim$(xProperty)) Then
   If UCase$(Trim$(Mid$(Trim$(x$), m3 + 1))) = UCase$(Trim$(xValue)) Then
    methd$ = " Value already recorded. Aborting write."
    Close #FA
    GoTo 9 ''Already there, abort
   Else
    m1 = n: Exit Do ''Located, exit
   End If
  End If
  n = n + Len(x$) + 1 ''+ Line lenght + C; position
 Loop
 Close #FA
End If
FB = FreeFile
If m1 = 0 Then
 ''Append
 methd$ = methd$ + "Appending. "
 Open xFile$ For Append As #FB Len = 1
  Print #FB, xProperty$ + "=" + xValue
 Close #FB
Else
 ''Overwrite
 methd$ = methd$ + "Overwriting existant. "

 If Len(xValue) > m2 - m3 Then
3 ''Standard method
  methd$ = methd$ + "Doesn't fit in or is empty (using standard method). "

  ''Allocate swap before appending anything
  SwapFile$ = xSwpFile(xName)
  

  If Dir(xFile$) <> "" Then
   ''Rename databank file into swap file (if file is blank, don't do anything)
   'FileCopy xFile$, SwapFile$
   'Kill xFile$
   Name xFile$ As SwapFile$
   ''Find Property in swap file and append the remaining data in the databank file
   MainFN = FreeFile
   Open xFile$ For Append As #MainFN
   SwapFN = FreeFile
   Open SwapFile$ For Input As #SwapFN
   Found = False
   Do: Line Input #SwapFN, dF$
    ''If the line is a data line
    If InStr(dF$, "=") > 1 Then
     ''If the thing behind the "=" is our property...
     If UCase$(Trim$(xLine2Property(dF$))) = UCase$(Trim$(xProperty)) Then
      Found = True
     Else
      ''Otherwise append to the (supposably blank) databank file
      If Left$(Trim$(dF$), 1) = "=" Then dF$ = "" ''No property
      If Right$(Trim$(dF$), 1) = "=" Then dF$ = "" ''No value
      If Trim$(dF$) <> "" Then Print #MainFN, dF$
     End If
    Else
     ''Otherwise append to the (supposably blank) databank file
     If Left$(Trim$(dF$), 1) = "=" Then dF$ = "" ''No property
     If Trim$(dF$) <> "" Then Print #MainFN, dF$
    End If
   Loop Until EOF(SwapFN)
   Close #MainFN, #SwapFN
  Else
   Found = False
  End If
  
  ''The file now contains everything but the old property
  ''value, so simply append the new one and delete the swap
  If xValue <> "" Then
   ''Don't add anything if there is no value
   appendFN = FreeFile
   Open xFile$ For Append As #appendFN
    Print #appendFN, Trim$(xProperty); "="; Trim$(xValue)
   Close #appendFN
  End If
  Kill SwapFile$


 Else
  ''Inscribe
  methd$ = methd$ + "Inscribing. "
  If Len(xValue) < m2 - m3 Then
   xValue = xValue + String$(m2 - m3 - Len(xValue), " ")
   methd$ = methd$ + "String enlarged (to " + CStr(m2 - m3) + " bytes). "
  End If
  Open xFile$ For Random As #FB Len = 1
  bw = 0
  For c = m1 + m3 To m1 + m2 - 1
   Get #FB, c, e
   f = Mid$(xValue, c - (m1 + m3) + 1, 1)
   If e <> f Then Put #FB, c, f: bw = bw + 1
  Next c
  Close #FB
 End If
End If

9 ''Cache obvious value
If Not xNoOutputCaching And Not xNoCaching Then
 'If xPleaseLogs Then dLog "Cached [" + xName + "] (" + CStr(FileDateTime(xFile$)) + "), [" + xProperty + "], [" + xValue + "]"
 xSetCachedPos = (xSetCachedPos + 1) Mod 3
 xSetCachedName(xSetCachedPos) = Trim$(xFixName(xName))
 xSetCachedSysTDS(xSetCachedPos) = CStr(FileDateTime(xFixName(xName))) + " " + CStr(FileSystem.FileLen(xFixName(xName)))
 xSetCachedProperty(xSetCachedPos) = xProperty
 xSetCachedValue(xSetCachedPos) = xValue
End If

If xPleaseLogs Then
 dLog "Database " + xName + " serial " + Trim$(Str$(MainFN)) + " Set [" + xProperty + "], [" + xValue + "]"
 dLog " Methods: " + methd$
 dLog " Swap serial " + Trim$(Str$(SwapFN)) + " Set"
 dLog " Bytes inscribed " + Trim$(Str$(bw))
End If
Close #FA, #FB, #MainFN, #SwapFN, #appendFN
xProcFinnished = True
End Sub

Public Function xQuery(xName As String, xProperty As String) As String
xProcFinnished = False

''Get the value of a property
    On Error Resume Next
xQuery = ""
If xName = "" Then xQuery = "": Exit Function
If xProperty = "" Then xQuery = "": Exit Function
xFile$ = xFixName(xName)
If xFile$ = "" Or Dir$(xFile$) = "" Then
 If xPleaseLogs Then dLog "Database " + Trim$(xName) + " serial " + Trim$(CStr(InputFN)) + " Query [" + Trim$(xProperty) + "] ==>> DATABANK NOT FOUND!!"
 xQuery = "": Exit Function
End If

If Not xNoOutputCaching And Not xNoCaching Then
 ''DeCache from Set cache
 For c = 0 To 3
  If UCase$(Dir$(Trim$(xSetCachedName(c)))) <> UCase$(Trim$(xSetCachedName(c))) And Trim$(xSetCachedName(c)) <> "" And Right$(Trim$(xSetCachedName(c)), 1) <> "\" Then
   If Trim$(xSetCachedName(c)) = Trim$(xFile$) And Trim$(CStr(FileDateTime(xFile$)) + " " + CStr(FileSystem.FileLen(xFile$))) = Trim$(xSetCachedSysTDS(c)) And Trim$(xSetCachedProperty(c)) = Trim$(xProperty) Then
    If xPleaseLogs Then dLog "Database " + Trim$(xName) + " Query [" + Trim$(xProperty) + "] ==>> DeCached from write cache [" + Trim$(xSetCachedValue(c)) + "]"
    xQuery = Trim$(xSetCachedValue(c))
    Exit Function
   End If
  End If
 Next c
End If

If Not xNoCaching Then
 ''DeCache from Query cache
 For c = 0 To 3
  If UCase$(Dir$(Trim$(xQueryCachedName(c)))) <> UCase$(Trim$(xQueryCachedName(c))) And Trim$(xQueryCachedName(c)) <> "" And Right$(Trim$(xQueryCachedName(c)), 1) <> "\" Then
   If Trim$(xQueryCachedName(c)) = Trim$(xFile$) And Trim$(CStr(FileDateTime(xFile$)) + " " + CStr(FileSystem.FileLen(xFile$))) = Trim$(xQueryCachedSysTDS(c)) And Trim$(xQueryCachedProperty(c)) = Trim$(xProperty) Then
    If xPleaseLogs Then dLog "Database " + Trim$(xName) + " Query [" + Trim$(xProperty) + "] ==>> DeCached from read cache [" + Trim$(xQueryCachedValue(c)) + "]"
    xQuery = Trim$(xQueryCachedValue(c))
    Exit Function
   End If
  End If
 Next c
End If

''Don't read if the file is empty
If FileLen(xFile$) = 0 Then xQuery = "": Exit Function

''Find the right Property and then extract the Value
If Dir(xFile$) <> "" Then
InputFN = FreeFile
Open xFile$ For Input As #InputFN
Found = False
Do: Line Input #InputFN, dA$
If InStr(dA$, "=") > 0 Then
 If UCase$(Trim$(Mid$(dA$, 1, InStr(dA$, "=") - 1))) = UCase$(Trim$(xProperty)) Then
  Found = True
  xQuery = Trim$(Mid$(dA$, InStr(dA$, "=") + 1))
  Exit Do
 End If
End If
Loop Until EOF(InputFN)
Close #InputFN
End If
''If entry found to be blank, delete it's record
''to save disk space and rewrite time, improove stability
If Found And xQuery = "" Then xRemoveEntry xName, xProperty

''Avoid bugs
If Not Found Then xQuery = ""

If Not xNoCaching Then
 ''Cache result
 'If xPleaseLogs Then dLog "Cached [" + xName + "] (" + CStr(FileDateTime(xFile$)) + "), [" + xProperty + "], [" + xQuery + "]"

 xQueryCachedPos = (xQueryCachedPos + 1) Mod 3
 xQueryCachedName(xQueryCachedPos) = Trim$(xFixName(xName))
 xQueryCachedSysTDS(xQueryCachedPos) = Trim$(CStr(FileDateTime(xFile$)) + " " + CStr(FileSystem.FileLen(xFile$)))
 xQueryCachedProperty(xQueryCachedPos) = Trim$(xProperty)
 xQueryCachedValue(xQueryCachedPos) = Trim$(xQuery)
End If

If xPleaseLogs Then dLog "Database " + Trim$(xName) + " serial " + Trim$(CStr(InputFN)) + " Query [" + Trim$(xProperty) + "] ==>> [" + xQuery + "]"
Close #InputFN
xProcFinnished = True
End Function

Public Function xNextSerial(xName As String, xProperty As String) As Long
xProcFinnished = False
''Find the next available serial number for a property name
    On Error Resume Next

If Not xNoCaching Then
 ''DeCache
 For c = 0 To 3
  If xNextSerialCachedName(c) = xName And xNextSerialCachedSysTDS(c) = CStr(FileDateTime(xFixName(xName))) + " " + CStr(FileSystem.FileLen(xFixName(xName))) And xNextSerialCachedProperty(c) = xProperty Then
   xNextSerial = xNextSerialCachedSerial(c)
   Exit Function
  End If
 Next c
End If

xNextSerial = 0
Do: n = n + 1
tmp$ = xQuery(xName, xProperty + Trim$(Str$(n)))
Loop Until Trim$(tmp$) = ""
xNextSerial = n

If Not xNoCaching Then
 ''Cache result
 xNextSerialCachedPos = (xNextSerialCachedPos + 1) Mod 3
 xNextSerialCachedName(xNextSerialCachedPos) = xName
 xNextSerialCachedSysTDS(xNextSerialCachedPos) = CStr(FileDateTime(xFixName(xName))) + " " + CStr(FileSystem.FileLen(xFixName(xName)))
 xNextSerialCachedProperty(xNextSerialCachedPos) = xProperty
 xNextSerialCachedSerial(xNextSerialCachedPos) = xNextSerial
End If
xProcFinnished = True
End Function

Public Sub xRemoveEntry(xName As String, xProperty As String)
xProcFinnished = False
''Remove an entry, given a property name
    On Error Resume Next

''Optimizing procedure: Use xSet procedure and add a blank line --> removal automaticaly concluded.
If xPleaseLogs Then dLog "Database " + xName + " serial " + Trim$(Str$(MainFN)) + " RemoveEntry [" + xProperty + "]"
xSet xName, xProperty, ""
xProcFinnished = True
End Sub

Public Sub xRemoveSerial(xName As String, xProperty As String, xValue As String)
xProcFinnished = False
''Remove a serial entry, given the base property name and it's value

''The last serial should be sought, written over
''the to-be-removed and then removed (as an entry)

    On Error Resume Next

''Get the last serial entry number
n = Me.xNextSerial(xName, xProperty) - 1
''If no entries, nothing to do
If n = 0 Then
 Exit Sub
''If one entriy, simply delete it
ElseIf n = 1 Then
 Me.xRemoveEntry xName, xProperty + "1"
''Otherwise...
Else
 ''Find the entry we need to remove
 TProp$ = Me.xFindSerial(xName, xProperty, xValue)
 ''Overwrite
 Me.xSet xName, TProp$, Me.xQuery(xName, xProperty + Trim$(Str$(n)))
 ''Delete the last serial
 Me.xRemoveEntry xName, xProperty + Trim$(Str$(n))
End If
xProcFinnished = True
End Sub

Public Sub xSimpleRemoveSerial(xName As String, xProperty As String, xSerial As Long)
xProcFinnished = False
''Remove a serial entry, given the base property name and it's value

''The last serial should be sought, written over
''the to-be-removed and then removed (as an entry)

    On Error Resume Next

''Get the last serial entry number
n = Me.xNextSerial(xName, xProperty) - 1
''If no entries, nothing to do
If n = 0 Then
 Exit Sub
''If one entriy, simply delete it
ElseIf n = 1 Then
 Me.xRemoveEntry xName, xProperty + "1"

''If last entriy, simply delete it
ElseIf n = xSerial Then
 Me.xRemoveEntry xName, xProperty + CStr(n)
 
''Otherwise...
Else
 ''Find the entry we need to remove
 TProp$ = xProperty + CStr(xSerial)
 ''Overwrite
 Me.xSet xName, TProp$, xQuery(xName, xProperty + CStr(n))
 ''Delete the last serial
 Me.xRemoveEntry xName, xProperty + CStr(n)
End If
xProcFinnished = True
End Sub

Public Function xFindEntry(xName As String, xValue As String) As String
xProcFinnished = False
''Find the property name by it's value
    On Error Resume Next
xFindEntry = ""
xFile$ = xFixName(xName)
''If the database exists
If Dir(xFile$) <> "" Then
 ''Find Property in file
 MainFN = FreeFile
 Open xFile$ For Input As #MainFN
 Do: Line Input #MainFN, dB$
  ''If the thing after the "=" includes our value...
  If InStr(1, Mid$(dB$, InStr(dB$, "=") + 1), UCase$(Trim$(xValue)), vbTextCompare) > 0 Then
  'If UCase$(Trim$(Mid$(a$, InStr(a$, "=") + 1))) = UCase$(Trim$(xValue)) Then
   xFindEntry = Trim$(Mid$(dB$, 1, InStr(dB$, "=") - 1))
  End If
 Loop Until EOF(MainFN)
Close #MainFN
End If
If xPleaseLogs Then dLog "Database " + xName + " serial " + Trim$(Str$(MainFN)) + " FindEntry [" + xValue + "] ==>> [" + xFindEntry + "]"
Close #MainFN
xProcFinnished = True
End Function

Public Function xFindSerial(xName As String, xProperty As String, xValue As String) As String
xProcFinnished = False
''Find the property + serial number by the base property name and it's value
    On Error Resume Next
xFindSerial = ""
xFile$ = xFixName(xName)
''If the database exists
If Dir(xFile$) <> "" Then
 ''Find Property in file
 MainFN = FreeFile
 Open xFile$ For Input As #MainFN
 Do: Line Input #MainFN, dC$
  ''If the thing after the "=" is our value and the thing before the "=" contains our property...
  If UCase$(Trim$(Mid$(dC$, InStr(dC$, "=") + 1))) = UCase$(Trim$(xValue)) _
  And InStr(UCase$(Trim$(Mid$(dC$, 1, InStr(dC$, "=") - 1))), UCase$(Trim$(xProperty))) Then
   xFindSerial = Trim$(Mid$(dC$, 1, InStr(dC$, "=") - 1))
  End If
 Loop Until EOF(MainFN)
Close #MainFN
End If
If xPleaseLogs Then dLog "Database " + xName + " serial " + Trim$(Str$(MainFN)) + " FindSerial ==>> [" + xFindSerial + "]"
Close #MainFN
xProcFinnished = True
End Function

Public Function xQueryByLineNumber(xName As String, xLineNumber As Long) As xPropertyAndValue
xProcFinnished = False
''Get the value and property on a specific LineNumber
    On Error Resume Next

xQueryByLineNumber.xProperty = ""
xQueryByLineNumber.xValue = ""
Dim n As Long
xFile$ = xFixName(xName)
If xFile$ = "" Then Exit Function
If Right$(xFile$, 1) = "\" Then Exit Function
If Dir$(xFile$) = ""Then Exit Function
If FileLen(xFile$) = 0 Then Exit Function

If Not xNoCaching Then
 ''Decache
 For c = 0 To 3
  If xQueryBLNCachedName(c) = xName And CStr(FileDateTime(xFile$)) + " " + CStr(FileSystem.FileLen(xFile$)) = xQueryBLNCachedSysTDS(c) And xQueryBLNCachedLN(c) = xLineNumber Then
   If xPleaseLogs Then dLog "Database " + xName + " Query by linenumber [" + CStr(xLineNumber) + "] ==>> DeCached [" + xQueryBLNCachedValue(c).xProperty + " = " + xQueryBLNCachedValue(c).xValue + "]"
   xQueryByLineNumber = xQueryBLNCachedValue(c)
   Exit Function
  End If
 Next c
End If
''Scroll to the correct LineNumber
If Dir(xFile$) <> "" Then
 InputFN = FreeFile
 Open xFile$ For Input As #InputFN
 n = 0
 Do: n = n + 1
  ''Read
  Line Input #InputFN, dD$
  If InStr(dD$, "=") Then
   ''Split the read
   xQueryByLineNumber.xProperty = Trim$(Mid$(dD$, 1, InStr(dD$, "=") - 1))
   xQueryByLineNumber.xValue = Trim$(Mid$(dD$, InStr(dD$, "=") + 1))
   ''Confirm when at correct LineNumber
   If n = xLineNumber Then GoTo 9
  End If
 Loop Until EOF(InputFN)
 Close #InputFN
 ''If it ever gets to this point, return blank
 xQueryByLineNumber.xProperty = ""
 xQueryByLineNumber.xValue = ""
 If Not xNoCaching Then
  ''Didn't get a result, but got the number of lines; cache 'em
  xByLineCachedPos = (xByLineCachedPos + 1) Mod 3
  xByLineCachedName(xByLineCachedPos) = xName
  xByLineCachedSysTDS(xByLineCachedPos) = CStr(FileDateTime(xFile$)) + " " + CStr(FileSystem.FileLen(xFile$))
  xByLineCachedNumberOfLines(xByLineCachedPos) = n
 End If
End If

9

If Not xNoCaching Then
 ''Cache
 xQueryBLNCachedPos = (xQueryBLNCachedPos + 1) Mod 3
 xQueryBLNCachedName(xQueryBLNCachedPos) = xName
 xQueryBLNCachedSysTDS(xQueryBLNCachedPos) = CStr(FileDateTime(xFile$)) + " " + CStr(FileSystem.FileLen(xFile$))
 xQueryBLNCachedLN(xQueryBLNCachedPos) = xLineNumber
 xQueryBLNCachedValue(xQueryBLNCachedPos) = xQueryByLineNumber
End If

If xPleaseLogs Then dLog "Database " + xName + " serial " + Trim$(Str$(InputFN)) + " QueryByLineNumber [" + Trim$(Str$(xLineNumber)) + "] ==>> [" + xQueryByLineNumber.xProperty + "=" + xQueryByLineNumber.xValue + "]"
Close #InputFN
xProcFinnished = True
End Function

Public Function xNumberOfLines(xName As String) As Long
xProcFinnished = False
''Get the number of lines the databank is made of
  On Error Resume Next
Dim n As Long
xFile$ = xFixName(xName)
If FileLen(xFile$) = 0 Then Exit Function

If Not xNoCaching Then
 ''DeCache
 For c = 0 To 3
  If xByLineCachedName(c) = xName And xByLineCachedSysTDS(c) = CStr(FileDateTime(xFile$)) + " " + CStr(FileSystem.FileLen(xFile$)) Then
   xNumberOfLines = xByLineCachedNumberOfLines(c)
   Exit Function
  End If
 Next c
End If

n = 0
''Scroll to the correct LineNumber
If Dir(xFile$) <> "" Then
 InputFN = FreeFile
 Open xFile$ For Input As #InputFN
 Do: n = n + 1
  ''Read
  Line Input #InputFN, dD$
 Loop Until EOF(InputFN)
 Close #InputFN
End If

If dD$ = "" Then xNumberOfLines = n - 1 Else xNumberOfLines = n

If Not xNoCaching Then
 ''Cache result
 xByLineCachedPos = (xByLineCachedPos + 1) Mod 3
 xByLineCachedName(xByLineCachedPos) = xName
 xByLineCachedSysTDS(xByLineCachedPos) = CStr(FileDateTime(xFile$)) + " " + CStr(FileSystem.FileLen(xFile$))
 xByLineCachedNumberOfLines(xByLineCachedPos) = xNumberOfLines
End If

If xPleaseLogs Then dLog "Database " + xName + " serial " + Trim$(Str$(InputFN)) + "(number of lines) ==>> [" + Trim$(Str$(xNumberOfLines)) + "]"
Close #InputFN
xProcFinnished = True
End Function

Public Function xFindSerialNumber(xName As String, xProperty As String, xValue As String) As Long
xProcFinnished = False
    On Error Resume Next
s$ = xFindSerial(xName, xProperty, xValue)
xFindSerialNumber = Val(Mid$(s$, Len(xProperty) + 1))
xProcFinnished = True
End Function

Public Function xNextSerialFile(xPath As String) As String
xProcFinnished = False
    On Error Resume Next
Dim n As Long
''Fix the path
If Right$(xPath, 1) <> "\" Then xPath = xPath + "\"
''Increase until found an available slot
Do: n = n + 1
 xName = xPath + Trim$(Str$(n))
Loop While Dir(xName) <> ""
''Produce the result
xNextSerialFile = xPath + Trim$(Str$(n))
xProcFinnished = True
End Function

Public Sub xAppendSerial(xName As String, xProperty As String, yValue As String)
xProcFinnished = False
    On Error Resume Next
If xPleaseLogs Then dLog "Database " + xName + " Append serial [" + xProperty + "] [" + yValue + "]"
n = Me.xNextSerial(xName, xProperty)
Me.xSet xName, xProperty + Trim$(Str$(n)), yValue

''Cache obvious next serial number
If Not xNoOutputCaching And Not xNoCaching Then
 xNextSerialCachedPos = (xNextSerialCachedPos + 1) Mod 3
 xNextSerialCachedName(xNextSerialCachedPos) = xName
 xNextSerialCachedSysTDS(xNextSerialCachedPos) = CStr(FileDateTime(xFixName(xName))) + " " + CStr(FileSystem.FileLen(xFixName(xName)))
 xNextSerialCachedProperty(xNextSerialCachedPos) = xProperty
 xNextSerialCachedSerial(xNextSerialCachedPos) = n + 1
End If
xProcFinnished = True
End Sub

Public Sub xRemoveAllSerials(xName As String, xProperty As String)
xProcFinnished = False
''Remove an entire series, given a base property name
    On Error Resume Next
''Set filenames
xFile$ = xFixName(xName)
SwapFile$ = xSwpFile(xName)

If xFile$ = "" Or Dir$(xFile$) = "" Then
 If xPleaseLogs Then dLog "Database " + xName + " serial " + Trim$(Str$(MainFN)) + " RemoveAllSerials [" + xProperty + "] DATABANK NOT FOUND!!"
 Exit Sub
End If

If Dir(xFile$) <> "" Then
''XX Find Property in file and save the remaining data in the swap file XX
''Rename the original into the swap file
Name xFile$ As SwapFile$
''Find Property in swap file and append the remaining data to original
MainFN = FreeFile
Open xFile$ For Append As #MainFN
SwapFN = FreeFile
Open SwapFile$ For Input As #SwapFN
Found = False
Do: Line Input #SwapFN, dE$
 ''If the thing before the "=" dosen't contain our base property, copy to original
 If InStr(1, Trim$(Mid$(dE$, 1, InStr(dE$, "=") - 1)), Trim$(xProperty), vbTextCompare) = 0 Then
  Print #MainFN, dE$
 End If
Loop Until EOF(SwapFN)
Close #MainFN, #SwapFN
End If

'Kill xFile$
'Name SwapFile$ As xFile$
''Remove the swap file, everything is in the original
Kill SwapFile$

If xPleaseLogs Then
 dLog "Database " + xName + " serial " + Trim$(Str$(MainFN)) + " RemoveAllSerials [" + xProperty + "]"
 dLog "Swap serial " + Trim$(Str$(SwapFN)) + " RemoveAllSerials"
End If
Close #MainFN, #SwapFN
xProcFinnished = True
End Sub

Public Sub xSimpleAddSerial(xName As String, xProperty As String, xValue As String, xSerial As Long)
xProcFinnished = False
''Simpler method
    On Error Resume Next
''Fix filename
xFile$ = xFixName(xName)
''Append
P$ = Trim$(xProperty) + Trim$(Str$(xSerial))
FN = FreeFile
''If it already exists, delete it
'If Not xQuery(xName, p$) = "" Then
xRemoveEntry xName, P$
Open xFile$ For Append As #FN
Print #FN, P$ + "=" + xValue
Close #FN
If xPleaseLogs Then dLog "Database " + xName + " serial " + Trim$(Str$(FN)) + " SimpleAddSerial [" + xProperty + "], [" + xValue + "]"
Close #FN
xProcFinnished = True
End Sub

Public Function xLine2Property(xLine As String) As String
xProcFinnished = False
    On Error Resume Next
 xLine2Property = Trim$(Mid$(xLine, 1, InStr(xLine, "=") - 1))
xProcFinnished = True
End Function

Public Function xLine2Value(xLine As String) As String
xProcFinnished = False
    On Error Resume Next
 xLine2Value = Trim$(Mid$(xLine, InStr(xLine, "=") + 1))
xProcFinnished = True
End Function

Public Function xExtractPropertySerial(xProperty As String) As Long
xProcFinnished = False
    On Error Resume Next
Dim xExtractPropertySerialtmp As Long, Counttmp As Long
xExtractPropertySerialtmp = 0
For Counttmp = 1 To Len(xProperty)
 If Asc(Mid$(xProperty, Counttmp, 1)) < Asc("A") Then xExtractPropertySerialtmp = Val(Mid$(xProperty, Counttmp)): Exit For
Next Counttmp
xExtractPropertySerial = xExtractPropertySerialtmp
xProcFinnished = True
End Function


Private Function xSwpFile(xName As String) As String
xProcFinnished = False
    On Error Resume Next
''Swap filename creation tool

Dim tmpTimer As Long

'If xWaitFile Then
 If xName <> xFileLoc Then
  '' C:\Jure\Meson\File.txt
  ''         ^^^^^ ********
  '' C:\Jure\Meson
  theDir$ = Mid$(xName, 1, InStrRev(xName, "\") - 1)
  '' Meson
  theDir$ = Mid$(theDir$, InStrRev(theDir$, "\") + 1)
 End If
 If theDir$ = "" Then theDir$ = "Root"
 
 xSwpFile = Me.xTemporaryPath + "\DSP." + theDir$ + "." + Dir$(xName) + ".TMP"
 
 ''Wait for the file (since on error resume next is in place, use multiple lines)
  tmp$ = "xyz"
  
  Do
  tmp$ = Dir$(xSwpFile)
   If tmp$ <> "" Then
    If xProblematicSwapFN <> xSwpFile Then xProblematicSwapTime = DateTime.Timer
    xProblematicSwapFN = xSwpFile
    If Abs(DateTime.Timer - tmpTimer) > 1 Then
     If xPleaseLogs Then dLog "!!! Swap conflict [" + xSwpFile + "] Waiting..."
     tmpTimer = DateTime.Timer
    End If
    If Abs(DateTime.Timer - xProblematicSwapTime) > 7 Then FileSystem.Kill xSwpFile: dLog "!!! Swap conflict [" + xSwpFile + "] TIMEOUT. File removed."
   End If
  Loop Until tmp$ = ""

If xPleaseLogs Then dLog "Database [" + xName + "] ==>> allocated swap [" + xSwpFile + "]"
xProcFinnished = True
End Function

Private Sub dLog(xEntryText As String)
xProcFinnished = False
  On Error Resume Next
yFN = FreeFile
''Prepare time record
If Int(DateTime.Timer) <> DateTime.Timer Then ts$ = Trim$(Str$(Abs(DateTime.Timer - Int(DateTime.Timer)))) Else ts$ = ""
Open App.Path + "\Database_IO.log" For Append As #yFN
Print #yFN, Date$; " "; Time$; ts$; "| "; xEntryText
Close #yFN
xProcFinnished = True
End Sub

Public Sub dEnableLogging(xBackups As Boolean)
xProcFinnished = False
 On Error Resume Next
If xBackups Then
 If Dir$(App.Path + "\Database_IO.log.x") <> "" Then Kill App.Path + "\Database_IO.log.x"
 If Dir$(App.Path + "\Database_IO.log") <> "" Then Name App.Path + "\Database_IO.log" As App.Path + "\Database_IO.log.x"
Else
 If Dir$(App.Path + "\Database_IO.log") <> "" Then Kill App.Path + "\Database_IO.log"
End If
xPleaseLogs = True
xProcFinnished = True
End Sub

Public Sub xThwapDataCache()
xProcFinnished = False
 On Error Resume Next
For c = 0 To 3
 xQueryCachedName(c) = ""
 xQueryCachedSysTDS(c) = ""
 xQueryCachedProperty(c) = ""
 xQueryCachedValue(c) = ""
 xQueryBLNCachedName(c) = ""
 xQueryBLNCachedSysTDS(c) = ""
 xQueryBLNCachedLN(c) = 0
 xQueryBLNCachedValue(c).xProperty = ""
 xQueryBLNCachedValue(c).xValue = ""
 xSetCachedName(c) = ""
 xSetCachedSysTDS(c) = ""
 xSetCachedProperty(c) = ""
 xSetCachedValue(c) = ""
 xNextSerialCachedName(c) = ""
 xNextSerialCachedSysTDS(c) = ""
 xNextSerialCachedProperty(c) = ""
 xNextSerialCachedSerial(c) = 0
 xByLineCachedName(c) = ""
 xByLineCachedSysTDS(c) = ""
 xByLineCachedNumberOfLines(c) = 0
Next c
xQueryCachedPos = 0
xQueryBLNCachePos = 0
xSetCachedPos = 0
xNextSerialCachedPos = 0
xByLineCachedPos = 0
xProcFinnished = True
End Sub

Public Sub xModerateDataCache(xExcludeNameOrProperty As String)
xProcFinnished = False
 On Error Resume Next
xExcludeNameOrProperty = UCase$(Trim$(xExcludeNameOrProperty))
For c = 0 To 3
 If UCase$(Trim$(xQueryCachedName(c))) = xExcludeNameOrProperty Or UCase$(Trim$(xQueryCachedProperty(c))) = xExcludeNameOrProperty Then
  xQueryCachedName(c) = ""
  xQueryCachedSysTDS(c) = ""
  xQueryCachedProperty(c) = ""
  xQueryCachedValue(c) = ""
 End If
 If UCase$(Trim$(xQueryBLNCachedName(c))) = xExcludeNameOrProperty Or UCase$(Trim$(xQueryBLNCachedValue(c).xProperty)) = xExcludeNameOrProperty Then
  xQueryBLNCachedName(c) = ""
  xQueryBLNCachedSysTDS(c) = ""
  xQueryBLNCachedLN(c) = 0
  xQueryBLNCachedValue(c).xProperty = ""
  xQueryBLNCachedValue(c).xValue = ""
 End If
 If UCase$(Trim$(xSetCachedName(c))) = xExcludeNameOrProperty Or UCase$(Trim$(xSetCachedProperty(c))) = xExcludeNameOrProperty Then
  xSetCachedName(c) = ""
  xSetCachedSysTDS(c) = ""
  xSetCachedProperty(c) = ""
  xSetCachedValue(c) = ""
 End If
 If UCase$(Trim$(xNextSerialCachedName(c))) = xExciludeNameOrProperty Or UCase$(Trim$(xNextSerialCachedProperty(c))) = xExcludeNameOrProperty Then
  xNextSerialCachedName(c) = ""
  xNextSerialCachedSysTDS(c) = ""
  xNextSerialCachedProperty(c) = ""
  xNextSerialCachedSerial(c) = 0
 End If
 If UCase$(Trim$(xByLineCachedName(c))) = xExcludeNameOrProperty Then
  xByLineCachedName(c) = ""
  xByLineCachedSysTDS(c) = ""
  xByLineCachedNumberOfLines(c) = 0
 End If
Next c
xProcFinnished = True
End Sub

Private Sub UserControl_Initialize()
xProcFinnished = False
 On Error Resume Next
xFindTemporaryPath
xProcFinnished = True
End Sub

