VERSION 5.00
Begin VB.UserControl File 
   ClientHeight    =   765
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   765
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   765
   ScaleWidth      =   765
   ToolboxBitmap   =   "File.ctx":0000
End
Attribute VB_Name = "File"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
''+-------------------------------------+
''| ICI style I/O PO file access module |
''+-------------------------------------+
''|     Made by Jure Sah of MesonAI     |
''|   TimeDateStamp:  18:11 30.6.2002   |
''+-------------------------------------+
''
''Type "me." in the VB code editing screen to get
''a list of functions and subroutines this module
''provides. Each subroutine or function does what
''it 's name suggests and all parameters and their
''formats are just as obvious.
''
''This module provides your program with the abbility
''to store and retrieve commands form ICI standard
''Post Office files and write log files with ease.
''ICI Post Office files are easily-accessable text
''files that contain command sequences in the
''following Format:
''
''--- Comment of command 1
''Set Source = ICI_Name
''Command Text
''May be multiline
''--- Comment of command 2
''Set Source = ICI_Name
''Command Text
''May be multiline
''--- Comment of command 3
''Set Source = ICI_Name
''Command Text
''May be multiline
''
''ICI Post Office files are processed serially, top down,
''where each command cluster (each new one begining with
''the --- and comment) is removed before the next one is
''processed.
''
''This module requires modules DATA and STATUS that
''comply to the ICI standard and are normaly included
''in this distribution.
''
''ICI FILE (18:11 30.6.2002) License
''
''IMPORTANT:
''Please read the file license.txt carefully before
''using this software. By using, copying or
''redistributing the software, you accept and agree to
''become bound by the terms of the license. Please do
''not use this software, if you do not accept the terms
''of the license.
''
''ICI style I/O PO file access module (18:11 30.6.2002)
''(referred to in license.txt as "the software") has
''been developed by Jure Sah of MesonAI in Ljubljana,
''Slovenia. You can contact Jure Sah trough the
''following e-mail address:
''
''    jure.sah@guest.arnes.si
''
''or by any other means that you may find.
''

Public fPleaseLogs As Boolean, fInnitializing As Boolean
Public fTemporaryPath As String, fErrorWarning As Boolean
Public fProcFinnished As Boolean

Public Type xSourceAndMSG
 xSource As String
 xMSG As String
End Type

Private fTmpSplitSource As xSourceAndMSG
Public fTmpMergeSource As String
Public fTmpFixName As String, fOrigFixName As String

Public Sub fFindTemporaryPath()
fProcFinnished = False
  On Error Resume Next
fInnitializing = True
If fTemporaryPath = "" Then fTemporaryPath = Environ$("ICI")
If fTemporaryPath = "" Then fTemporaryPath = Environ$("TEMP")
If fTemporaryPath = "" Then fTemporaryPath = Environ$("TMP")
If fTemporaryPath = "" Then fTemporaryPath = App.Path

If fPleaseLogs Then
 xLog "CFP_use.log", "Innitialized interface file access with tempdir [" + fTemporaryPath + "]"
 xLog "CFP_use.log", "   "
End If
fInnitializing = False
fProcFinnished = True
End Sub

Public Sub xDeleteEntry(xFile As String)
fProcFinnished = False
  On Error Resume Next
Randomize Timer
Dim Copy_now As Boolean, Already_got_an_entry As Boolean, xSwapFile As String

''Fix the name
xFile = fFixName(xFile)

If FileLen(xFile) > 0 Then
 Copy_now = False
 Already_got_an_entry = False
 ''Name a temporary file and make sure it doesn't already exist
 xSwapFile = xSwpFile(xFile)
 
 'FN1 = FreeFile
 'Open xFile For Input As #FN1
 'FN2 = FreeFile
 'Open xSwapFile For Output As #FN2
 'Do
 '    Line Input #FN1, a$
 '    If Left$(a$, 3) = "---" Then
 '        If Already_got_an_entry Then Copy_now = True
 '        Already_got_an_entry = True
 '    End If
 '    ''When past the first entry, copy to swap file
 '    If Copy_now Then Print #FN2, a$
 'Loop Until EOF(FN1)
 'Close #FN1, #FN2
 '''Swap swap file with original
 'Kill xFile
 'Name xSwapFile As xFile
 
 ''Current = Copy everything else to swap file, then rename the swap file into current
 ''New = Rename orignal into swap, then copy everything else to the end of the current (if anything new since)
 
 Name xFile As xSwapFile
 FN1 = FreeFile
 Open xSwapFile For Input As #FN1
 FN2 = FreeFile
 Open xFile For Append As #FN2
 Do
     Line Input #FN1, FA$
     If Left$(FA$, 3) = "---" Then
         If Already_got_an_entry Then Copy_now = True
         Already_got_an_entry = True
     End If
     ''When past the first entry, copy to swap file
     If Copy_now Then Print #FN2, FA$
 Loop Until EOF(FN1)
 Close #FN1, #FN2
 ''Swap swap file with original
 Kill xSwapFile
 If fPleaseLogs Then xLog "CFP_use.log", "Deleted top entry from " + xFile + "," + Str$(FN1) + ", swap " + xSwapFile + "," + Str$(FN2)
End If
fProcFinnished = True
End Sub

Public Function xReadEntry(xFile As String) As String
fProcFinnished = False
  On Error Resume Next
Dim OK_to_quit  As Boolean, Already_got_an_entry As Boolean

''Error block
If Trim$(xFile) = "" Then Exit Function

''Fix the name
xFile = fFixName(xFile)

If FileLen(xFile) > 0 Then
 OK_to_quit = False
 Already_got_an_entry = False
 
 ''Don't read if the file is empty
 If FileLen(xFile) = 0 Then xReadEntry = "": Exit Function
 
 ''Read an entry
 FN = FreeFile
 Open xFile For Input As #FN
 Do
     Line Input #FN, FB$
     If Left$(FB$, 3) = "---" Then
         If Already_got_an_entry Then OK_to_quit = True
         Already_got_an_entry = True
         Else
         xReadEntry = xReadEntry + FB$ + vbCrLf
     End If
 Loop Until EOF(FN) Or OK_to_quit
 Close #FN
End If
If fPleaseLogs And Not xReadEntry = "" Then xLog "CFP_use.log", "Read (" + xFile + "," + Str$(FN) + "): [" + xReadEntry + "]"
fProcFinnished = True
End Function

Public Sub xWriteEntry(xFile As String, xEntryText As String)
fProcFinnished = False
  On Error Resume Next

''Error block
If Trim$(xEntryText) = "" Or Trim$(xFile) = "" Then Exit Sub

''Fix the name
xFile = fFixName(xFile)

''Prepare time record
If Int(DateTime.Timer) <> DateTime.Timer Then ts$ = Trim$(Str$(Abs(DateTime.Timer - Int(DateTime.Timer)))) Else ts$ = ""

FN = FreeFile
Open xFile For Append As #FN
Print #FN, "--- Entry by CFP Default on " + Date$ + " " + Time$ + ts$
Print #FN, xEntryText
Close #FN
If fPleaseLogs Then xLog "CFP_use.log", "Wrote down (" + xFile + "," + Str$(FN) + "):" + vbCrLf + " --- Entry by CFP Default on " + Date$ + " " + Time$ + ts$ + "| " + xEntryText
'Dxebug.Print "("; FN; ")", "("; xFile; ")", "("; xEntryText; ")"
fProcFinnished = True
End Sub

Public Function xTrim(xS As String) As String
fProcFinnished = False
  On Error Resume Next
''Strip leading and trailing CR and linefeed
If Left$(xS, 2) = vbCrLf Then xS = Mid$(xS, 3)
If Right$(xS, 2) = vbCrLf Then xS = Mid$(xS, 1, Len(xS) - 2)
''Strip leading and trailing spaces
xTrim = Trim$(xS)
fProcFinnished = True
End Function

Public Function xSplitSource(xText As String) As xSourceAndMSG
fProcFinnished = False
  On Error Resume Next
If UCase$(Mid$(xText, 1, 10)) = "SET SOURCE" Then
 ''        "SET SOURCE = 1.2.3.4"
 yN = InStr(xText, "=")
 xSplitSource.xSource = Trim$(Mid$(xText, yN + 1, InStr(xText, vbCrLf) - yN - 1))
 t$ = Trim$(Mid$(xText, InStr(xText, vbCrLf) + 2))
 If Left$(t$, 2) = vbCrLf Then t$ = Mid$(t$, 3)
 If Right$(t$, 2) = vbCrLf Then t$ = Mid$(t$, 1, Len(t$) - 2)
 xSplitSource.xMSG = t$
Else
 xSplitSource.xSource = "0.0.0.0"
 xSplitSource.xMSG = xText
End If
fTmpSplitSource = xSplitSource
fProcFinnished = True
End Function

Public Function xMergeSource(xSource As String, xText As String) As String
fProcFinnished = False
  On Error Resume Next
''Error block
If Trim$(xText) = "" Then Exit Function

If Trim$(xSource) = "" Or Trim$(xSource) = "0.0.0.0" Then xSource = "0.0.0.0"
xMergeSource = "SET SOURCE = " + xSource + vbCrLf + xText
fTmpMergeSource = xMergeSource
fProcFinnished = True
End Function

Public Sub xLog(xFile As String, xEntryText As String)
fProcFinnished = False
  On Error Resume Next
''Fix the name (avoid standard procedure, not to spoil debbuging loggings)
If InStr(xFile, ":") = 0 Then xFile = App.Path + "\" + xFile
If InStr(xFile, ".") = 0 Then xFile = xFile + ".log"

''Prepare time record
If Int(DateTime.Timer) <> DateTime.Timer Then ts$ = Trim$(Str$(Abs(DateTime.Timer - Int(DateTime.Timer)))) Else ts$ = ""

''Write it down
xTXTAppend xFile, Date$ + " " + Time$ + ts$ + "| " + xEntryText
fProcFinnished = True
End Sub

Public Sub xTXTAppend(xFile As String, xText As String)
fProcFinnished = False
  On Error Resume Next

''Fix the name
xFile = fFixName(xFile)
''HDD I/O Append
yFN = FreeFile
Open xFile For Append As #yFN
Print #yFN, xText
Close #yFN
fProcFinnished = True
End Sub

'Public Function xReadEntriesByLineNumber(xFile As String, N As Long) As String
'  on error Resume Next
'Dim OK_to_quit  As Boolean, Already_got_N_entries As Long
'
'OK_to_quit = False
'Already_got_N_entries = 0
'xReadEntriesByLineNumber = ""
'
'''Don't read if the file is empty
'If FileLen(xFile) = 0 Then xReadEntriesByLineNumber = "": Exit Function
'
'''Read an entry
'FN = FreeFile
'Open xFile For Input As #FN
'Do
' Line Input #FN, a$
' If Left$(a$, 3) = "---" Then
'  If Already_got_N_entries > N Then OK_to_quit = True
'  Already_got_N_entries = Already_got_N_entries + 1
' ElseIf Already_got_N_entries = N Then
'  xReadEntriesByLineNumber = xReadEntriesByLineNumber + a$ + " | "
' End If
'Loop Until EOF(FN) Or OK_to_quit
'Close #FN
'End Function

Private Function xSwpFile(xName As String) As String
fProcFinnished = False
  On Error Resume Next

''If file cannot be found attempt to create it, if that fails, signal error condition
If Dir$(xName) = "" Then xWriteEntry xName, ""
fErrorWarning = (Dir$(xName) = "")

inst = 0
2 inst = inst + 1
xSwpFile = Me.fTemporaryPath + "\CFP." + Dir$(xName) + "." + Hex$(inst) + "." + Hex$(Rnd * &HFFF) + ".TMP"
'Dxebug.Print "["; xName; "]", "["; xSwpFile; "]"
If Not (Dir$(xSwpFile) = "") Then GoTo 2
'If fPleaseLogs Then xLog "CFP_use.log", " File [" + xName + "] ==>> allocated swap [" + xSwpFile + "]"
fProcFinnished = True
End Function

Private Function fFixName(xName As String) As String
fProcFinnished = False
  On Error Resume Next
If fOrigFixName = xName Then fFixName = fTmpFixName: Exit Function
fOrigFixName = xName
If fTemporaryPath = "" And Not fInnitializing Then fFindTemporaryPath
If InStr(xName, ":") = 0 Then xName = App.Path + "\" + xName
If Left$(xName, 1) = "\" Then xPath$ = fTemporaryPath
fTmpFixName = xPath$ + xName
fFixName = fTmpFixName
fProcFinnished = True
End Function

Public Sub fEnableLogging(xBackups As Boolean)
fProcFinnished = False
 On Error Resume Next
If Backups Then
 If Dir$(App.Path + "\CFP_use.log.x") <> "" Then Kill App.Path + "\CFP_use.log.x"
 If Dir$(App.Path + "\CFP_use.log") <> "" Then Name App.Path + "\CFP_use.log" As App.Path + "\CFP_use.log.x"
Else
 If Dir$(App.Path + "\CFP_use.log") <> "" Then Kill App.Path + "\CFP_use.log"
End If
fPleaseLogs = True
fProcFinnished = True
End Sub

Private Sub UserControl_Initialize()
fProcFinnished = False
Me.fFindTemporaryPath
fProcFinnished = True
End Sub
