VERSION 5.00
Begin VB.UserControl cData 
   ClientHeight    =   1185
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1170
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   1185
   ScaleWidth      =   1170
   ToolboxBitmap   =   "cData.ctx":0000
End
Attribute VB_Name = "cData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
''+-------------------------------------------+
''| ICI style I/O database file access module |
''+-------------------------------------------+
''|       Made by Jure Sah of MesonAI         |
''|      TimeDateStamp: 17:07 6.7.2003        |
''+-------------------------------------------+

Public xTemporaryPath As String
Attribute xTemporaryPath.VB_VarDescription = "Is the temporary path used by the control"
Public DataFilesPath As String
Attribute DataFilesPath.VB_VarDescription = "Indicates a path where all the program's files should be located"
Public xPleaseLogs As Boolean
Attribute xPleaseLogs.VB_VarDescription = "Indicates that the control creates debug logs"
Public xWaitFile As Boolean
Public xNoOutputCaching As Boolean
Attribute xNoOutputCaching.VB_VarDescription = "Indicates that data outputs should not be cached"
Public xNoCaching As Boolean
Attribute xNoCaching.VB_VarDescription = "Indicates that data caching should not be used"
Public xInnitializing As Boolean
Attribute xInnitializing.VB_VarDescription = "Indicates that the control is innitializing"

Type myPropertyAndValue
 xProperty As String
 xValue As String
End Type

Public Sub xSetOCXConfigs()
Attribute xSetOCXConfigs.VB_Description = "Store variable values to OCX"
Data.xTemporaryPath = xTemporaryPath
Data.DataFilesPath = DataFilesPath
Data.xPleaseLogs = xPleaseLogs
Data.xWaitFile = xWaitFile
Data.xNoOutputCaching = xNoOutputCaching
Data.xNoCaching = xNoCaching
File.xLog "OCX reconfig", "DATA.SetOCX"
End Sub

Public Sub xGetOCXConfigs()
Attribute xGetOCXConfigs.VB_Description = "Retrieves variables from OCX"
xTemporaryPath = Data.xTemporaryPath
DataFilesPath = Data.DataFilesPath
xPleaseLogs = Data.xPleaseLogs
xWaitFile = Data.xWaitFile
xNoOutputCaching = Data.xNoOutputCaching
xNoCaching = Data.xNoCaching
xInnitializing = Data.xInnitializing
File.xLog "OCX reconfig", "DATA.GetOCX"
End Sub

Public Sub xFindTemporaryPath()
Attribute xFindTemporaryPath.VB_Description = "Finds the required temporary directory"
Data.xFindTemporaryPath
End Sub

Public Function xFixName(xName As String) As String
Attribute xFixName.VB_Description = "Makes a filename valid"
xFixName = Data.xFixName(xName)
End Function

Public Sub xCreate(xName As String)
Attribute xCreate.VB_Description = "Creates a databank"
Data.xCreate xName
End Sub

Public Sub xRemove(xName As String)
Attribute xRemove.VB_Description = "Deletes or semi-deletes a databank"
Data.xRemove xName
End Sub

Public Sub xSet(xName As String, xProperty As String, xValue As String)
Attribute xSet.VB_Description = "Stores a property value to a databank"
Data.xSet xName, xProperty, xValue
End Sub

Public Function xQuery(xName As String, xProperty As String) As String
Attribute xQuery.VB_Description = "Retrieves a property value from a databank, provided the databank and property name"
xQuery = Data.xQuery(xName, xProperty)
End Function

Public Function xNextSerial(xName As String, xProperty As String) As Long
Attribute xNextSerial.VB_Description = "Finds the next available serial number of a property in a databank"
xNextSerial = Data.xNextSerial(xName, xProperty)
End Function

Public Sub xRemoveEntry(xName As String, xProperty As String)
Attribute xRemoveEntry.VB_Description = "Removes a property value from a databank, provided the databank and property name"
Data.xRemoveEntry xName, xProperty
End Sub

Public Sub xRemoveSerial(xName As String, xProperty As String, xValue As String)
Attribute xRemoveSerial.VB_Description = "Removes a specific property out of a series without damaging  the rest of the series"
Data.xRemoveSerial xName, xProperty, xValue
End Sub

Public Sub xSimpleRemoveSerial(xName As String, xProperty As String, xSerial As Long)
Attribute xSimpleRemoveSerial.VB_Description = "Removes a serial of a property with a lighter procedure, with serial number provided"
Data.xSimpleRemoveSerial xName, xProperty, xSerial
End Sub

Public Function xFindEntry(xName As String, xValue As String) As String
Attribute xFindEntry.VB_Description = "Finds an entry in the databank (search by value)"
xFindEntry = Data.xFindEntry(xName, xValue)
End Function

Public Function xFindSerial(xName As String, xProperty As String, xValue As String) As String
Attribute xFindSerial.VB_Description = "Finds a serial property  in a databank (value provided)"
xFindSerial = Data.xFindSerial(xName, xProperty, xValue)
End Function

Public Function xQueryByLineNumber(xName As String, xLineNumber As Long) As myPropertyAndValue
Attribute xQueryByLineNumber.VB_Description = "Retrieves a property value from a databank, provided the databank and line number"
xQueryByLineNumber.xProperty = Data.xQueryByLineNumber(xName, xLineNumber).xProperty
xQueryByLineNumber.xValue = Data.xQueryByLineNumber(xName, xLineNumber).xValue
End Function

Public Function xNumberOfLines(xName As String) As Long
Attribute xNumberOfLines.VB_Description = "Returns the number of lines a databank contains"
xNumberOfLines = Data.xNumberOfLines(xName)
End Function

Public Function xFindSerialNumber(xName As String, xProperty As String, xValue As String) As Long
Attribute xFindSerialNumber.VB_Description = "Finds a serial number of a property."
xFindSerialNumber = Data.xFindSerialNumber(xName, xProperty, xValue)
End Function

Public Function xNextSerialFile(xPath As String) As String
Attribute xNextSerialFile.VB_Description = "Finds the next available serial for a databank name"
xNextSerialFile = Data.xNextSerialFile(xPath)
End Function

Public Sub xAppendSerial(xName As String, xProperty As String, yValue As String)
Attribute xAppendSerial.VB_Description = "Appends a serial databank entry"
Data.xAppendSerial xName, xProperty, yValue
End Sub

Public Sub xRemoveAllSerials(xName As String, xProperty As String)
Attribute xRemoveAllSerials.VB_Description = "Removes the entire series of properties from a databank, provided the databank and base property name"
xRemoveAllSerials xName, xProperty
End Sub

Public Sub xSimpleAddSerial(xName As String, xProperty As String, xValue As String, xSerial As Long)
Attribute xSimpleAddSerial.VB_Description = "Adds a serial of a property with a lighter procedure, with serial number provided"
Data.xSimpleAddSerial xName, xProperty, xValue, xSerial
End Sub

Public Function xLine2Property(xLine As String) As String
Attribute xLine2Property.VB_Description = "Returns the property part of a databank line"
xLine2Property = Data.xLine2Property(xLine)
End Function

Public Function xLine2Value(xLine As String) As String
Attribute xLine2Value.VB_Description = "Returns the value part of a databank line"
xLine2Value = Data.xLine2Value(xLine)
End Function

Public Function xExtractPropertySerial(xProperty As String) As Long
Attribute xExtractPropertySerial.VB_Description = "Extracts the serial number from a property name"
xExtractPropertySerial = Data.xExtractPropertySerial(xProperty)
End Function

Public Sub dEnableLogging(xBackups As Boolean)
Attribute dEnableLogging.VB_Description = "Enables debug info logging"
Data.dEnableLogging xBackups
End Sub

Public Sub xThwapDataCache()
Attribute xThwapDataCache.VB_Description = "Clears the cache"
Data.xThwapDataCache
End Sub

Public Sub xModerateDataCache(xExcludeNameOrProperty As String)
Attribute xModerateDataCache.VB_Description = "Scans the cache and removes info of a specific databank or property"
Data.xModerateDataCache xExcludeNameOrProperty
End Sub

Private Sub UserControl_Initialize()
Data.xFindTemporaryPath
xGetOCXConfigs
End Sub
