VERSION 5.00
Begin VB.UserControl cICSA 
   ClientHeight    =   1275
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1305
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   1275
   ScaleWidth      =   1305
   ToolboxBitmap   =   "cICSA.ctx":0000
End
Attribute VB_Name = "cICSA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
''+-------------------------------------+
''| ICI style I/O ICSA interface module |
''+-------------------------------------+
''|     Made by Jure Sah of MesonAI     |
''|   TimeDateStamp:  17:33 30.6.2002   |
''+-------------------------------------+


Public xICSAFile As String, iSource As String, icsaPleaseLogs As Boolean
Attribute xICSAFile.VB_VarDescription = "Contains the interface file between the control and ICSA"
Attribute iSource.VB_VarDescription = "Contains the information about the source of the last message"
Attribute icsaPleaseLogs.VB_VarDescription = "Indicates debug info logs will be written"

Public Enum myProcessType
 Not_provided = 0
 FileLoc_link = 1
 ICSA_Process = 2
 MISC = 99
End Enum

Public Enum myPathType
 Plain = 1
 URL = 2
End Enum

Public Type myURL
 xProtocol As String
 xComputer As String
 xPath As String
End Type

Public icsaTmpRecieve As String, icsaTmpURLAnalizeProtocol As String, icsaTmpURLAnalizeComputer As String, icsaTmpURLAnalizePath As String
Attribute icsaTmpRecieve.VB_VarDescription = "Contains the cached value of the ""Recieve"" function"
Attribute icsaTmpURLAnalizeProtocol.VB_VarDescription = "Contains the cached value of the ""AnalizeURL"" function (protocol part)"
Attribute icsaTmpURLAnalizeComputer.VB_VarDescription = "Contains the cached value of the ""AnalizeURL"" function (computer part)"
Attribute icsaTmpURLAnalizePath.VB_VarDescription = "Contains the cached value of the ""AnalizeURL"" function (path part)"

Public Sub xGetOCXConfigs()
Attribute xGetOCXConfigs.VB_Description = "Retrieves the variables from the OCX"
xICSAFile = ICSA.xICSAFile
iSource = ICSA.iSource
icsaPleaseLogs = ICSA.icsaPleaseLogs
icsaTmpRecieve = ICSA.icsaTmpRecieve
icsaTmpURLAnalizeComputer = ICSA.icsaTmpURLAnalize.xComputer
icsaTmpURLAnalizePath = ICSA.icsaTmpURLAnalize.xPath
icsaTmpURLAnalizeProtocol = ICSA.icsaTmpURLAnalize.xProtocol
End Sub

Public Sub xSetOCXConfigs()
Attribute xSetOCXConfigs.VB_Description = "Stores the variable values to the OCX"
ICSA.xICSAFile = xICSAFile
ICSA.iSource = iSource
ICSA.icsaPleaseLogs = icsaPleaseLogs
ICSA.icsaTmpRecieve = icsaTmpRecieve
ICSA.icsaTmpURLAnalize.xComputer = icsaTmpURLAnalizeComputer
ICSA.icsaTmpURLAnalize.xPath = icsaTmpURLAnalizePath
ICSA.icsaTmpURLAnalize.xProtocol = icsaTmpURLAnalizeProtocol
End Sub

Public Sub xFindInterfaceFile()
Attribute xFindInterfaceFile.VB_Description = "Locates the interface file between the control and ICSA"
ICSA.xFindInterfaceFile
End Sub

Public Sub xSendText(xMyProcessName As String, xToProcess As String, xToProcessType As myProcessType, xTargetComputer As String, xText As String)
Attribute xSendText.VB_Description = "Sends the text to the ICSA"
Select Case xProcessType
Case FileLoc_link: ICSA.xSendText xMyProcessName, xToProcess, FileLoc_link, xTargetComputer, xText
Case ICSA_Process: ICSA.xSendText xMyProcessName, xToProcess, ICSA_Process, xTargetComputer, xText
Case Not_provided: ICSA.xSendText xMyProcessName, xToProcess, Not_provided, xTargetComputer, xText
Case MISC: ICSA.xSendText xMyProcessName, xToProcess, MISC, xTargetComputer, xText
End Select
End Sub

Public Sub xSend(xMyProcessName As String, xToProcess As String, xToProcessType As myProcessType, xTargetComputer As String, xText As String)
Attribute xSend.VB_Description = "Sends a message to the ICSA"
ICSA.xSend xMyProcessName, xToProcess, xToProcessType, xTargetComputer, xText
End Sub

Public Function xRecieve(xMyProcessName As String) As String
Attribute xRecieve.VB_Description = "Recieves a message directly from the ICSA"
xRecieve = ICSA.xRecieve(xMyProcessName)
End Function

Public Sub xDisplay(xTargetComputer As String, xText As String)
Attribute xDisplay.VB_Description = "Orders the ICSA to display a message (old)"
ICSA.xDisplay xTargetComputer, xText
End Sub

Public Sub xDirList(xMyProcessName As String, xTargetComputer As String, xPath As String, xPathType As myPathType)
Attribute xDirList.VB_Description = "Orders the ICSA to retrieve a directory list"
ICSA.xDirList xMyProcessName, xTargetComputer, xPath, xPathType
End Sub

Public Sub xUpload(xMyProcessName As String, xTargetComputer As String, xFromPath As String, xToPath As String, xToPathType As myPathType)
Attribute xUpload.VB_Description = "Orders the ICSA to upload a file"
ICSA.xUpload xMyProcessName, xTargetComputer, xFromPath, xToPath, xToPathType
End Sub

Public Sub xDownload(xMyProcessName As String, xTargetComputer As String, xFromPath As String, xFromPathType As myPathType, xToPath As String)
Attribute xDownload.VB_Description = "Orders the ICSA to download a file"
ICSA.xDownload xMyProcessName, xTargetComputer, xFromPath, xFromPathType, xToPath
End Sub

Public Sub xDelete(xMyProcessName As String, xTargetComputer As String, xPath As String, xPathType As myPathType)
Attribute xDelete.VB_Description = "Orders the ICSA to delete a file"
ICSA.xDelete xMyProcessName, xTargetComputer, xPath, xPathType
End Sub

Public Sub xDisconnect(xTargetComputer As String)
Attribute xDisconnect.VB_Description = "Orders the ICSA to disconnect a computer (to conserve socket resources)"
ICSA.xDisconnect xTargetComputer
End Sub

Public Function xURLAnalize(xURL As String) As myURL
Attribute xURLAnalize.VB_Description = "Analizes an URL, seperating it to a path (with filename), a computer name and protocol name"
xURLAnalize.xComputer = ICSA.xURLAnalize(xURL).xComputer
xURLAnalize.xPath = ICSA.xURLAnalize(xURL).xPath
xURLAnalize.xProtocol = ICSA.xURLAnalize(xURL).xProtocol
End Function

Public Sub icsaEnableLogging(xBackups As Boolean)
Attribute icsaEnableLogging.VB_Description = "Enables debug info logging"
ICSA.icsaEnableLogging xBackups
End Sub

Private Sub UserControl_Initialize()
ICSA.xFindInterfaceFile
xGetOCXConfigs
End Sub
