VERSION 5.00
Begin VB.UserControl cSTATUS 
   ClientHeight    =   1065
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1080
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   1065
   ScaleWidth      =   1080
   ToolboxBitmap   =   "cSTATUS.ctx":0000
End
Attribute VB_Name = "cSTATUS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
''+-------------------------------------+
''| ICI STATUS databank registry module |
''+-------------------------------------+
''|     Made by Jure Sah of MesonAI     |
''|   TimeDateStamp:  18:38 30.6.2002   |
''+-------------------------------------+

Public xdSTATUS As String, xdPleaseLogs As Boolean, xdNoDebug As Boolean
Attribute xdSTATUS.VB_VarDescription = "Contains the filename of the STATUS databank"
Attribute xdPleaseLogs.VB_VarDescription = "Indicates debug info logs will be written"
Attribute xdNoDebug.VB_VarDescription = "Indicates the control should not use it's internal debugging procedures"
Public xdLoadOnce As Boolean
Attribute xdLoadOnce.VB_VarDescription = "Indicates the control should optimize it's preformance by loading essesional information only on startup"

Public xdTmpQueryExtraRegister As String
Attribute xdTmpQueryExtraRegister.VB_VarDescription = "Contains the cached output of the ""QueryExtraRegister"" function"
Public xdTmpGetLocalID As String
Attribute xdTmpGetLocalID.VB_VarDescription = "Contains the cached output of the ""GetLocalID"" function"
Public xdTmpGetICIPulse As Long
Attribute xdTmpGetICIPulse.VB_VarDescription = "Contains the cached output of the ""GetICIPulse"" function"
Public xdTmpIsAppRunning As Boolean
Attribute xdTmpIsAppRunning.VB_VarDescription = "Contains the cached output of the ""GetIsAppRunning"" function"
Public xdTmpGetAppRunTime As String
Attribute xdTmpGetAppRunTime.VB_VarDescription = "Contains the cached output of the ""GetAppRunTime"" function"
Public xdTmpGetAppRunDate As String
Attribute xdTmpGetAppRunDate.VB_VarDescription = "Contains the cached output of the ""GetAppRunDate"" function"
Public xdTmpGetAppRunPath As String
Attribute xdTmpGetAppRunPath.VB_VarDescription = "Contains the cached output of the ""GetAppRunPath"" function"
Public xdTmpIsAppInstalled As Boolean
Attribute xdTmpIsAppInstalled.VB_VarDescription = "Contains the cached output of the ""GetIsAppInstalled"" function"

Public Sub xGetOCXConfigs()
Attribute xGetOCXConfigs.VB_Description = "Retrieves the variable values from the OCX"
xdSTATUS = STATUS.xdSTATUS
xdPleaseLogs = STATUS.xdPleaseLogs
xdNoDebug = STATUS.xdNoDebug
xdLoadOnce = STATUS.xdLoadOnce
xdTmpQueryExtraRegister = STATUS.xdTmpQueryExtraRegister
xdTmpGetLocalID = STATUS.xdTmpGetLocalID
xdTmpGetICIPulse = STATUS.xdTmpGetICIPulse
xdTmpIsAppRunning = STATUS.xdTmpIsAppRunning
xdTmpGetAppRunTime = STATUS.xdTmpGetAppRunTime
xdTmpGetAppRunDate = STATUS.xdTmpGetAppRunDate
xdTmpGetAppRunPath = STATUS.xdTmpGetAppRunPath
xdTmpIsAppInstalled = STATUS.xdTmpIsAppInstalled
End Sub

Public Sub xSetOCXConfigs()
Attribute xSetOCXConfigs.VB_Description = "Stores the variable values to the OCX"
STATUS.xdSTATUS = xdSTATUS
STATUS.xdPleaseLogs = xdPleaseLogs
STATUS.xdNoDebug = xdNoDebug
STATUS.xdLoadOnce = xdLoadOnce
STATUS.xdTmpQueryExtraRegister = xdTmpQueryExtraRegister
STATUS.xdTmpGetLocalID = xdTmpGetLocalID
STATUS.xdTmpGetICIPulse = xdTmpGetICIPulse
STATUS.xdTmpIsAppRunning = xdTmpIsAppRunning
STATUS.xdTmpGetAppRunTime = xdTmpGetAppRunTime
STATUS.xdTmpGetAppRunDate = xdTmpGetAppRunDate
STATUS.xdTmpGetAppRunPath = xdTmpGetAppRunPath
STATUS.xdTmpIsAppInstalled = xdTmpIsAppInstalled
End Sub

Public Sub xLocateSTATUSDataBank()
Attribute xLocateSTATUSDataBank.VB_Description = "Locates the STATUS databank"
STATUS.xLocateSTATUSDataBank
End Sub

Public Sub xRegister(xMyAppName As String)
Attribute xRegister.VB_Description = "Registers an application to the STATUS databank as running"
STATUS.xRegister xMyAppName
End Sub

Public Sub xRegisterExtra(xMyAppName As String, Register As String, Value As String)
Attribute xRegisterExtra.VB_Description = "Registers extra information to the STATUS databank (Identification and Author for example)"
STATUS.xRegisterExtra xMyAppName, Register, Value
End Sub

Public Sub xUnRegister(xMyAppName As String)
Attribute xUnRegister.VB_Description = "Registers an application to the STATUS databank as NOT running anymore"
STATUS.xUnRegister xMyAppName
End Sub

Public Function xQueryExtraRegister(xMyAppName As String, Register As String) As String
Attribute xQueryExtraRegister.VB_Description = "Returns extra information the application might have written to the STATUS databank (Identification and Author for example)"
xQueryExtraRegister = STATUS.xQueryExtraRegister(xMyAppName, Register)
End Function

Public Function xGetLocalID() As String
Attribute xGetLocalID.VB_Description = "Returns the name of the local computer"
xGetLocalID = STATUS.xGetLocalID
End Function

Public Function xGetICIPulse() As Long
Attribute xGetICIPulse.VB_Description = "Returns the value of the ICI Pulse (should be set to timer interval)"
xGetICIPulse = STATUS.xGetICIPulse
End Function

Public Function xIsAppRunning(xAppName As String) As Boolean
Attribute xIsAppRunning.VB_Description = "Determines if the application is currently running"
xIsAppRunning = STATUS.xIsAppRunning(xAppName)
End Function

Public Sub xRunApp(xAppName As String, WindowStyle As VBA.VbAppWinStyle)
Attribute xRunApp.VB_Description = "Runs the application in a new instance"
STATUS.xRunApp xAppName, WindowStyle
End Sub

Public Sub xMakeAppRunning(xAppName As String, WindowStyle As VBA.VbAppWinStyle)
Attribute xMakeAppRunning.VB_Description = "Makes sure the application is running"
STATUS.xMakeAppRunning xAppName, WindowStyle
End Sub

Public Function xGetAppRunTime(xAppName As String) As String
Attribute xGetAppRunTime.VB_Description = "Returns the last run time of an application"
xGetAppRunTime = STATUS.xGetAppRunTime(xAppName)
End Function

Public Function xGetAppRunDate(xAppName As String) As String
Attribute xGetAppRunDate.VB_Description = "Returns the last run date of an application"
xGetAppRunDate = STATUS.xGetAppRunDate(xAppName)
End Function

Public Function xGetAppRunPath(xAppName As String) As String
Attribute xGetAppRunPath.VB_Description = "Returns the last known location of an application"
xGetAppRunPath = STATUS.xGetAppRunPath(xAppName)
End Function

Public Sub xdEnableLogging(xBackups As Boolean)
Attribute xdEnableLogging.VB_Description = "Enables debug info logging"
STATUS.xdEnableLogging xBackups
End Sub

Public Function xIsAppInstalled(xAppName As String) As Boolean
Attribute xIsAppInstalled.VB_Description = "Determines if the application is installed"
xIsAppInstalled = STATUS.xIsAppInstalled(xAppName)
End Function

Private Sub UserControl_Initialize()
STATUS.xLocateSTATUSDataBank
STATUS.xGetLocalID
STATUS.xGetICIPulse
xGetOCXConfigs
End Sub

